import { EventEmitter } from '@angular/core';
import { Subject } from 'rxjs';
import { AdaptiveCriteria, AppliedSearchType, IDataTableChangeEvent, IDataTableFilter, IDataTablePreferences, IDataTableSelectionOption, IDataTableSort } from '../interfaces';
import * as i0 from "@angular/core";
export declare class DataTableState<T> {
    selectionSource: Subject<void>;
    paginationSource: Subject<unknown>;
    sortFilterSource: Subject<unknown>;
    resetSource: Subject<void>;
    expandSource: Subject<unknown>;
    allMatchingSelectedSource: Subject<unknown>;
    dataLoaded: Subject<void>;
    dataLoadingSource: Subject<unknown>;
    sort: IDataTableSort;
    filter: IDataTableFilter | IDataTableFilter[];
    where: {
        query: string;
        criteria?: AdaptiveCriteria;
        form: any;
    };
    page: number;
    pageSize: number;
    globalSearch: string;
    selectedRows: Map<string, T>;
    expandedRows: Set<string>;
    outsideFilter: any;
    isForceRefresh: boolean;
    selectionOptions: IDataTableSelectionOption[];
    updates: EventEmitter<IDataTableChangeEvent>;
    retainSelected: boolean;
    savedSearchName: string;
    appliedSearchType: AppliedSearchType;
    displayedColumns: string[];
    get userFiltered(): boolean;
    get userFilteredInternal(): boolean;
    get selected(): T[];
    reset(fireUpdate?: boolean, persistUserFilters?: any): void;
    clearSort(fireUpdate?: boolean): void;
    clearFilter(fireUpdate?: boolean): void;
    clearQuery(fireUpdate?: boolean): void;
    clearSelected(fireUpdate?: boolean): void;
    onSelectionChange(): void;
    onExpandChange(targetId?: number): void;
    onPaginationChange(isPageSizeChange: boolean, pageSize: number): void;
    onSortFilterChange(): void;
    setInitialSortFilter(preferences: any): void;
    setState(preferences: IDataTablePreferences, fireUpdate?: boolean, persistUserFilters?: boolean): void;
    checkRetainment(caller: string, allMatchingSelected?: boolean): void;
    private transformFilters;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataTableState<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DataTableState<any>>;
}
