import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, HostBinding, Input, NgModule } from '@angular/core';
import { BooleanInput } from 'novo-elements/utils';
import * as i1 from '@angular/cdk/observers';
import { ObserversModule } from '@angular/cdk/observers';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
class NovoIconComponent {
    set alt(value) {
        this.ariaLabel = value;
    }
    get alt() {
        return this.ariaLabel;
    }
    set name(iconName) {
        this.iconName = `bhi-${iconName}`;
    }
    get name() {
        return this.iconName;
    }
    get hb_classBinding() {
        return [this.color ? `text-color-${this.color}` : null, this.size ? `text-size-${this.size}` : null].filter(Boolean).join(' ');
    }
    constructor(element, cdr) {
        this.element = element;
        this.cdr = cdr;
        this.shape = 'box';
        this.role = 'img';
    }
    ngAfterViewInit() {
        if (this.element.nativeElement.textContent.trim()) {
            Promise.resolve().then(() => {
                this.name = this.element.nativeElement.textContent.trim();
                this.cdr.markForCheck();
            });
        }
    }
    projectContentChanged(record) {
        this.name = this.element.nativeElement.textContent.trim();
        this.cdr.detectChanges();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoIconComponent, deps: [{ token: i0.ElementRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: NovoIconComponent, selector: "novo-icon", inputs: { raised: "raised", theme: "theme", shape: "shape", color: "color", size: "size", smaller: "smaller", larger: "larger", alt: "alt", name: "name" }, host: { properties: { "class.novo-icon-raised": "this.raised", "attr.theme": "this.theme", "attr.shape": "this.shape", "attr.role": "this.role", "attr.aria-label": "this.ariaLabel", "class.icon-size-smaller": "this.smaller", "class.icon-size-larger": "this.larger", "class": "this.hb_classBinding" }, classAttribute: "novo-icon" }, ngImport: i0, template: `
    <i [class]="iconName"
      ><span (cdkObserveContent)="projectContentChanged($event)"><ng-content></ng-content></span
    ></i>
  `, isInline: true, styles: [":host{display:inline-flex;align-items:center;justify-content:center;font-size:1.2em;line-height:inherit;transition:color .2s ease-out,opacity .2s ease-out;vertical-align:middle}:host i{display:flex;justify-content:center;align-items:center;font-size:inherit;line-height:inherit;width:1em;height:1em;color:inherit;outline:none}:host i:before{color:inherit}:host i *{display:none!important}:host.text-capitalize{text-transform:capitalize}:host.text-uppercase{text-transform:uppercase}:host.text-nowrap{white-space:nowrap}:host.text-ellipsis{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}:host.text-size-default{font-size:inherit}:host.text-size-body{font-size:1.3rem}:host.text-size-xs{font-size:1rem}:host.text-size-sm{font-size:1.2rem}:host.text-size-md{font-size:1.3rem}:host.text-size-lg{font-size:1.6rem}:host.text-size-xl{font-size:2rem}:host.text-size-2xl{font-size:2.6rem}:host.text-size-3xl{font-size:3.2rem}:host.text-size-smaller{font-size:.8em}:host.text-size-larger{font-size:1.2em}:host.text-color-black{color:#000}:host.text-color-white{color:#fff}:host.text-color-gray{color:#9e9e9e}:host.text-color-grey{color:#9e9e9e}:host.text-color-offWhite{color:#f7f7f7}:host.text-color-bright{color:#f7f7f7}:host.text-color-light{color:#dbdbdb}:host.text-color-neutral{color:#4f5361}:host.text-color-dark{color:#3d464d}:host.text-color-orange{color:#ff6900}:host.text-color-navigation{color:#202945}:host.text-color-skyBlue{color:#009bdf}:host.text-color-steel{color:#5b6770}:host.text-color-metal{color:#637893}:host.text-color-sand{color:#f4f4f4}:host.text-color-silver{color:#e2e2e2}:host.text-color-stone{color:#bebebe}:host.text-color-ash{color:#a0a0a0}:host.text-color-slate{color:#707070}:host.text-color-onyx{color:#526980}:host.text-color-charcoal{color:#282828}:host.text-color-moonlight{color:#1a242f}:host.text-color-midnight{color:#202945}:host.text-color-darkness{color:#161f27}:host.text-color-navy{color:#0d2d42}:host.text-color-aqua{color:#3bafda}:host.text-color-ocean{color:#4a89dc}:host.text-color-mint{color:#37bc9b}:host.text-color-grass{color:#8cc152}:host.text-color-sunflower{color:#f6b042}:host.text-color-bittersweet{color:#eb6845}:host.text-color-grapefruit{color:#da4453}:host.text-color-carnation{color:#d770ad}:host.text-color-lavender{color:#967adc}:host.text-color-mountain{color:#9678b6}:host.text-color-info{color:#4a89dc}:host.text-color-positive{color:#4a89dc}:host.text-color-success{color:#8cc152}:host.text-color-negative{color:#da4453}:host.text-color-danger{color:#da4453}:host.text-color-error{color:#da4453}:host.text-color-warning{color:#f6b042}:host.text-color-empty{color:#cccdcc}:host.text-color-disabled{color:#bebebe}:host.text-color-background{color:#f7f7f7}:host.text-color-backgroundDark{color:#e2e2e2}:host.text-color-presentation{color:#5b6770}:host.text-color-bullhorn{color:#ff6900}:host.text-color-pulse{color:#3bafda}:host.text-color-company{color:#39d}:host.text-color-candidate{color:#4b7}:host.text-color-lead{color:#a69}:host.text-color-contact{color:#fa4}:host.text-color-clientcontact{color:#fa4}:host.text-color-opportunity{color:#625}:host.text-color-job{color:#b56}:host.text-color-joborder{color:#b56}:host.text-color-submission{color:#a9adbb}:host.text-color-sendout{color:#747884}:host.text-color-placement{color:#0b344f}:host.text-color-note{color:#747884}:host.text-color-contract{color:#454ea0}:host.text-color-jobCode{color:#696d79}:host.text-color-earnCode{color:#696d79}:host.text-color-invoiceStatement{color:#696d79}:host.text-color-billableCharge{color:#696d79}:host.text-color-payableCharge{color:#696d79}:host.text-color-user{color:#696d79}:host.text-color-corporateUser{color:#696d79}:host.text-color-distributionList{color:#696d79}:host.text-color-credential{color:#696d79}:host.text-color-person{color:#696d79}:host.margin-before{margin-top:.4rem}:host.margin-after{margin-bottom:.8rem}:host.text-length-small{max-width:40ch}:host.text-length-medium{max-width:55ch}:host.text-length-large{max-width:70ch}:host.text-weight-hairline{font-weight:100}:host.text-weight-thin{font-weight:200}:host.text-weight-light{font-weight:300}:host.text-weight-normal{font-weight:400}:host.text-weight-medium{font-weight:500}:host.text-weight-semibold{font-weight:600}:host.text-weight-bold{font-weight:700}:host.text-weight-extrabold{font-weight:800}:host.text-weight-heavy{font-weight:900}:host.text-weight-lighter{font-weight:lighter}:host.text-weight-bolder{font-weight:bolder}:host[theme=black] i{color:#fff;background:#000;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=black][shape=circle] i{border-radius:50%}:host[theme=white] i{color:#fff;background:#fff;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=white][shape=circle] i{border-radius:50%}:host[theme=gray] i{color:#fff;background:#9e9e9e;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=gray][shape=circle] i{border-radius:50%}:host[theme=grey] i{color:#fff;background:#9e9e9e;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=grey][shape=circle] i{border-radius:50%}:host[theme=offWhite] i{color:#fff;background:#f7f7f7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=offWhite][shape=circle] i{border-radius:50%}:host[theme=bright] i{color:#fff;background:#f7f7f7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=bright][shape=circle] i{border-radius:50%}:host[theme=light] i{color:#fff;background:#dbdbdb;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=light][shape=circle] i{border-radius:50%}:host[theme=neutral] i{color:#fff;background:#4f5361;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=neutral][shape=circle] i{border-radius:50%}:host[theme=dark] i{color:#fff;background:#3d464d;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=dark][shape=circle] i{border-radius:50%}:host[theme=orange] i{color:#fff;background:#ff6900;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=orange][shape=circle] i{border-radius:50%}:host[theme=navigation] i{color:#fff;background:#202945;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=navigation][shape=circle] i{border-radius:50%}:host[theme=skyBlue] i{color:#fff;background:#009bdf;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=skyBlue][shape=circle] i{border-radius:50%}:host[theme=steel] i{color:#fff;background:#5b6770;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=steel][shape=circle] i{border-radius:50%}:host[theme=metal] i{color:#fff;background:#637893;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=metal][shape=circle] i{border-radius:50%}:host[theme=sand] i{color:#fff;background:#f4f4f4;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=sand][shape=circle] i{border-radius:50%}:host[theme=silver] i{color:#fff;background:#e2e2e2;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=silver][shape=circle] i{border-radius:50%}:host[theme=stone] i{color:#fff;background:#bebebe;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=stone][shape=circle] i{border-radius:50%}:host[theme=ash] i{color:#fff;background:#a0a0a0;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=ash][shape=circle] i{border-radius:50%}:host[theme=slate] i{color:#fff;background:#707070;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=slate][shape=circle] i{border-radius:50%}:host[theme=onyx] i{color:#fff;background:#526980;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=onyx][shape=circle] i{border-radius:50%}:host[theme=charcoal] i{color:#fff;background:#282828;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=charcoal][shape=circle] i{border-radius:50%}:host[theme=moonlight] i{color:#fff;background:#1a242f;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=moonlight][shape=circle] i{border-radius:50%}:host[theme=midnight] i{color:#fff;background:#202945;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=midnight][shape=circle] i{border-radius:50%}:host[theme=darkness] i{color:#fff;background:#161f27;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=darkness][shape=circle] i{border-radius:50%}:host[theme=navy] i{color:#fff;background:#0d2d42;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=navy][shape=circle] i{border-radius:50%}:host[theme=aqua] i{color:#fff;background:#3bafda;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=aqua][shape=circle] i{border-radius:50%}:host[theme=ocean] i{color:#fff;background:#4a89dc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=ocean][shape=circle] i{border-radius:50%}:host[theme=mint] i{color:#fff;background:#37bc9b;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=mint][shape=circle] i{border-radius:50%}:host[theme=grass] i{color:#fff;background:#8cc152;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=grass][shape=circle] i{border-radius:50%}:host[theme=sunflower] i{color:#fff;background:#f6b042;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=sunflower][shape=circle] i{border-radius:50%}:host[theme=bittersweet] i{color:#fff;background:#eb6845;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=bittersweet][shape=circle] i{border-radius:50%}:host[theme=grapefruit] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=grapefruit][shape=circle] i{border-radius:50%}:host[theme=carnation] i{color:#fff;background:#d770ad;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=carnation][shape=circle] i{border-radius:50%}:host[theme=lavender] i{color:#fff;background:#967adc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=lavender][shape=circle] i{border-radius:50%}:host[theme=mountain] i{color:#fff;background:#9678b6;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=mountain][shape=circle] i{border-radius:50%}:host[theme=info] i{color:#fff;background:#4a89dc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=info][shape=circle] i{border-radius:50%}:host[theme=positive] i{color:#fff;background:#4a89dc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=positive][shape=circle] i{border-radius:50%}:host[theme=success] i{color:#fff;background:#8cc152;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=success][shape=circle] i{border-radius:50%}:host[theme=negative] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=negative][shape=circle] i{border-radius:50%}:host[theme=danger] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=danger][shape=circle] i{border-radius:50%}:host[theme=error] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=error][shape=circle] i{border-radius:50%}:host[theme=warning] i{color:#fff;background:#f6b042;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=warning][shape=circle] i{border-radius:50%}:host[theme=empty] i{color:#fff;background:#cccdcc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=empty][shape=circle] i{border-radius:50%}:host[theme=disabled] i{color:#fff;background:#bebebe;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=disabled][shape=circle] i{border-radius:50%}:host[theme=background] i{color:#fff;background:#f7f7f7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=background][shape=circle] i{border-radius:50%}:host[theme=backgroundDark] i{color:#fff;background:#e2e2e2;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=backgroundDark][shape=circle] i{border-radius:50%}:host[theme=presentation] i{color:#fff;background:#5b6770;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=presentation][shape=circle] i{border-radius:50%}:host[theme=bullhorn] i{color:#fff;background:#ff6900;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=bullhorn][shape=circle] i{border-radius:50%}:host[theme=pulse] i{color:#fff;background:#3bafda;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=pulse][shape=circle] i{border-radius:50%}:host[theme=company] i{color:#fff;background:#39d;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=company][shape=circle] i{border-radius:50%}:host[theme=candidate] i{color:#fff;background:#4b7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=candidate][shape=circle] i{border-radius:50%}:host[theme=lead] i{color:#fff;background:#a69;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=lead][shape=circle] i{border-radius:50%}:host[theme=contact] i{color:#fff;background:#fa4;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=contact][shape=circle] i{border-radius:50%}:host[theme=clientcontact] i{color:#fff;background:#fa4;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=clientcontact][shape=circle] i{border-radius:50%}:host[theme=opportunity] i{color:#fff;background:#625;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=opportunity][shape=circle] i{border-radius:50%}:host[theme=job] i{color:#fff;background:#b56;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=job][shape=circle] i{border-radius:50%}:host[theme=joborder] i{color:#fff;background:#b56;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=joborder][shape=circle] i{border-radius:50%}:host[theme=submission] i{color:#fff;background:#a9adbb;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=submission][shape=circle] i{border-radius:50%}:host[theme=sendout] i{color:#fff;background:#747884;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=sendout][shape=circle] i{border-radius:50%}:host[theme=placement] i{color:#fff;background:#0b344f;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=placement][shape=circle] i{border-radius:50%}:host[theme=note] i{color:#fff;background:#747884;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=note][shape=circle] i{border-radius:50%}:host[theme=contract] i{color:#fff;background:#454ea0;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=contract][shape=circle] i{border-radius:50%}:host[theme=jobCode] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=jobCode][shape=circle] i{border-radius:50%}:host[theme=earnCode] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=earnCode][shape=circle] i{border-radius:50%}:host[theme=invoiceStatement] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=invoiceStatement][shape=circle] i{border-radius:50%}:host[theme=billableCharge] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=billableCharge][shape=circle] i{border-radius:50%}:host[theme=payableCharge] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=payableCharge][shape=circle] i{border-radius:50%}:host[theme=user] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=user][shape=circle] i{border-radius:50%}:host[theme=corporateUser] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=corporateUser][shape=circle] i{border-radius:50%}:host[theme=distributionList] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=distributionList][shape=circle] i{border-radius:50%}:host[theme=credential] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=credential][shape=circle] i{border-radius:50%}:host[theme=person] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=person][shape=circle] i{border-radius:50%}:host.novo-icon-raised i{box-shadow:2px 2px #0003}:host[shape=circle] i{border-radius:50%}:host.icon-size-smaller{font-size:1em}:host.icon-size-larger{font-size:1.4em}\n"], dependencies: [{ kind: "directive", type: i1.CdkObserveContent, selector: "[cdkObserveContent]", inputs: ["cdkObserveContentDisabled", "debounce"], outputs: ["cdkObserveContent"], exportAs: ["cdkObserveContent"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
__decorate([
    BooleanInput(),
    __metadata("design:type", Boolean)
], NovoIconComponent.prototype, "smaller", void 0);
__decorate([
    BooleanInput(),
    __metadata("design:type", Boolean)
], NovoIconComponent.prototype, "larger", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoIconComponent, decorators: [{
            type: Component,
            args: [{ selector: 'novo-icon', changeDetection: ChangeDetectionStrategy.OnPush, template: `
    <i [class]="iconName"
      ><span (cdkObserveContent)="projectContentChanged($event)"><ng-content></ng-content></span
    ></i>
  `, host: {
                        class: 'novo-icon',
                    }, styles: [":host{display:inline-flex;align-items:center;justify-content:center;font-size:1.2em;line-height:inherit;transition:color .2s ease-out,opacity .2s ease-out;vertical-align:middle}:host i{display:flex;justify-content:center;align-items:center;font-size:inherit;line-height:inherit;width:1em;height:1em;color:inherit;outline:none}:host i:before{color:inherit}:host i *{display:none!important}:host.text-capitalize{text-transform:capitalize}:host.text-uppercase{text-transform:uppercase}:host.text-nowrap{white-space:nowrap}:host.text-ellipsis{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}:host.text-size-default{font-size:inherit}:host.text-size-body{font-size:1.3rem}:host.text-size-xs{font-size:1rem}:host.text-size-sm{font-size:1.2rem}:host.text-size-md{font-size:1.3rem}:host.text-size-lg{font-size:1.6rem}:host.text-size-xl{font-size:2rem}:host.text-size-2xl{font-size:2.6rem}:host.text-size-3xl{font-size:3.2rem}:host.text-size-smaller{font-size:.8em}:host.text-size-larger{font-size:1.2em}:host.text-color-black{color:#000}:host.text-color-white{color:#fff}:host.text-color-gray{color:#9e9e9e}:host.text-color-grey{color:#9e9e9e}:host.text-color-offWhite{color:#f7f7f7}:host.text-color-bright{color:#f7f7f7}:host.text-color-light{color:#dbdbdb}:host.text-color-neutral{color:#4f5361}:host.text-color-dark{color:#3d464d}:host.text-color-orange{color:#ff6900}:host.text-color-navigation{color:#202945}:host.text-color-skyBlue{color:#009bdf}:host.text-color-steel{color:#5b6770}:host.text-color-metal{color:#637893}:host.text-color-sand{color:#f4f4f4}:host.text-color-silver{color:#e2e2e2}:host.text-color-stone{color:#bebebe}:host.text-color-ash{color:#a0a0a0}:host.text-color-slate{color:#707070}:host.text-color-onyx{color:#526980}:host.text-color-charcoal{color:#282828}:host.text-color-moonlight{color:#1a242f}:host.text-color-midnight{color:#202945}:host.text-color-darkness{color:#161f27}:host.text-color-navy{color:#0d2d42}:host.text-color-aqua{color:#3bafda}:host.text-color-ocean{color:#4a89dc}:host.text-color-mint{color:#37bc9b}:host.text-color-grass{color:#8cc152}:host.text-color-sunflower{color:#f6b042}:host.text-color-bittersweet{color:#eb6845}:host.text-color-grapefruit{color:#da4453}:host.text-color-carnation{color:#d770ad}:host.text-color-lavender{color:#967adc}:host.text-color-mountain{color:#9678b6}:host.text-color-info{color:#4a89dc}:host.text-color-positive{color:#4a89dc}:host.text-color-success{color:#8cc152}:host.text-color-negative{color:#da4453}:host.text-color-danger{color:#da4453}:host.text-color-error{color:#da4453}:host.text-color-warning{color:#f6b042}:host.text-color-empty{color:#cccdcc}:host.text-color-disabled{color:#bebebe}:host.text-color-background{color:#f7f7f7}:host.text-color-backgroundDark{color:#e2e2e2}:host.text-color-presentation{color:#5b6770}:host.text-color-bullhorn{color:#ff6900}:host.text-color-pulse{color:#3bafda}:host.text-color-company{color:#39d}:host.text-color-candidate{color:#4b7}:host.text-color-lead{color:#a69}:host.text-color-contact{color:#fa4}:host.text-color-clientcontact{color:#fa4}:host.text-color-opportunity{color:#625}:host.text-color-job{color:#b56}:host.text-color-joborder{color:#b56}:host.text-color-submission{color:#a9adbb}:host.text-color-sendout{color:#747884}:host.text-color-placement{color:#0b344f}:host.text-color-note{color:#747884}:host.text-color-contract{color:#454ea0}:host.text-color-jobCode{color:#696d79}:host.text-color-earnCode{color:#696d79}:host.text-color-invoiceStatement{color:#696d79}:host.text-color-billableCharge{color:#696d79}:host.text-color-payableCharge{color:#696d79}:host.text-color-user{color:#696d79}:host.text-color-corporateUser{color:#696d79}:host.text-color-distributionList{color:#696d79}:host.text-color-credential{color:#696d79}:host.text-color-person{color:#696d79}:host.margin-before{margin-top:.4rem}:host.margin-after{margin-bottom:.8rem}:host.text-length-small{max-width:40ch}:host.text-length-medium{max-width:55ch}:host.text-length-large{max-width:70ch}:host.text-weight-hairline{font-weight:100}:host.text-weight-thin{font-weight:200}:host.text-weight-light{font-weight:300}:host.text-weight-normal{font-weight:400}:host.text-weight-medium{font-weight:500}:host.text-weight-semibold{font-weight:600}:host.text-weight-bold{font-weight:700}:host.text-weight-extrabold{font-weight:800}:host.text-weight-heavy{font-weight:900}:host.text-weight-lighter{font-weight:lighter}:host.text-weight-bolder{font-weight:bolder}:host[theme=black] i{color:#fff;background:#000;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=black][shape=circle] i{border-radius:50%}:host[theme=white] i{color:#fff;background:#fff;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=white][shape=circle] i{border-radius:50%}:host[theme=gray] i{color:#fff;background:#9e9e9e;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=gray][shape=circle] i{border-radius:50%}:host[theme=grey] i{color:#fff;background:#9e9e9e;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=grey][shape=circle] i{border-radius:50%}:host[theme=offWhite] i{color:#fff;background:#f7f7f7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=offWhite][shape=circle] i{border-radius:50%}:host[theme=bright] i{color:#fff;background:#f7f7f7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=bright][shape=circle] i{border-radius:50%}:host[theme=light] i{color:#fff;background:#dbdbdb;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=light][shape=circle] i{border-radius:50%}:host[theme=neutral] i{color:#fff;background:#4f5361;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=neutral][shape=circle] i{border-radius:50%}:host[theme=dark] i{color:#fff;background:#3d464d;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=dark][shape=circle] i{border-radius:50%}:host[theme=orange] i{color:#fff;background:#ff6900;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=orange][shape=circle] i{border-radius:50%}:host[theme=navigation] i{color:#fff;background:#202945;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=navigation][shape=circle] i{border-radius:50%}:host[theme=skyBlue] i{color:#fff;background:#009bdf;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=skyBlue][shape=circle] i{border-radius:50%}:host[theme=steel] i{color:#fff;background:#5b6770;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=steel][shape=circle] i{border-radius:50%}:host[theme=metal] i{color:#fff;background:#637893;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=metal][shape=circle] i{border-radius:50%}:host[theme=sand] i{color:#fff;background:#f4f4f4;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=sand][shape=circle] i{border-radius:50%}:host[theme=silver] i{color:#fff;background:#e2e2e2;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=silver][shape=circle] i{border-radius:50%}:host[theme=stone] i{color:#fff;background:#bebebe;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=stone][shape=circle] i{border-radius:50%}:host[theme=ash] i{color:#fff;background:#a0a0a0;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=ash][shape=circle] i{border-radius:50%}:host[theme=slate] i{color:#fff;background:#707070;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=slate][shape=circle] i{border-radius:50%}:host[theme=onyx] i{color:#fff;background:#526980;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=onyx][shape=circle] i{border-radius:50%}:host[theme=charcoal] i{color:#fff;background:#282828;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=charcoal][shape=circle] i{border-radius:50%}:host[theme=moonlight] i{color:#fff;background:#1a242f;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=moonlight][shape=circle] i{border-radius:50%}:host[theme=midnight] i{color:#fff;background:#202945;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=midnight][shape=circle] i{border-radius:50%}:host[theme=darkness] i{color:#fff;background:#161f27;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=darkness][shape=circle] i{border-radius:50%}:host[theme=navy] i{color:#fff;background:#0d2d42;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=navy][shape=circle] i{border-radius:50%}:host[theme=aqua] i{color:#fff;background:#3bafda;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=aqua][shape=circle] i{border-radius:50%}:host[theme=ocean] i{color:#fff;background:#4a89dc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=ocean][shape=circle] i{border-radius:50%}:host[theme=mint] i{color:#fff;background:#37bc9b;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=mint][shape=circle] i{border-radius:50%}:host[theme=grass] i{color:#fff;background:#8cc152;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=grass][shape=circle] i{border-radius:50%}:host[theme=sunflower] i{color:#fff;background:#f6b042;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=sunflower][shape=circle] i{border-radius:50%}:host[theme=bittersweet] i{color:#fff;background:#eb6845;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=bittersweet][shape=circle] i{border-radius:50%}:host[theme=grapefruit] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=grapefruit][shape=circle] i{border-radius:50%}:host[theme=carnation] i{color:#fff;background:#d770ad;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=carnation][shape=circle] i{border-radius:50%}:host[theme=lavender] i{color:#fff;background:#967adc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=lavender][shape=circle] i{border-radius:50%}:host[theme=mountain] i{color:#fff;background:#9678b6;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=mountain][shape=circle] i{border-radius:50%}:host[theme=info] i{color:#fff;background:#4a89dc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=info][shape=circle] i{border-radius:50%}:host[theme=positive] i{color:#fff;background:#4a89dc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=positive][shape=circle] i{border-radius:50%}:host[theme=success] i{color:#fff;background:#8cc152;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=success][shape=circle] i{border-radius:50%}:host[theme=negative] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=negative][shape=circle] i{border-radius:50%}:host[theme=danger] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=danger][shape=circle] i{border-radius:50%}:host[theme=error] i{color:#fff;background:#da4453;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=error][shape=circle] i{border-radius:50%}:host[theme=warning] i{color:#fff;background:#f6b042;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=warning][shape=circle] i{border-radius:50%}:host[theme=empty] i{color:#fff;background:#cccdcc;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=empty][shape=circle] i{border-radius:50%}:host[theme=disabled] i{color:#fff;background:#bebebe;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=disabled][shape=circle] i{border-radius:50%}:host[theme=background] i{color:#fff;background:#f7f7f7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=background][shape=circle] i{border-radius:50%}:host[theme=backgroundDark] i{color:#fff;background:#e2e2e2;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=backgroundDark][shape=circle] i{border-radius:50%}:host[theme=presentation] i{color:#fff;background:#5b6770;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=presentation][shape=circle] i{border-radius:50%}:host[theme=bullhorn] i{color:#fff;background:#ff6900;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=bullhorn][shape=circle] i{border-radius:50%}:host[theme=pulse] i{color:#fff;background:#3bafda;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=pulse][shape=circle] i{border-radius:50%}:host[theme=company] i{color:#fff;background:#39d;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=company][shape=circle] i{border-radius:50%}:host[theme=candidate] i{color:#fff;background:#4b7;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=candidate][shape=circle] i{border-radius:50%}:host[theme=lead] i{color:#fff;background:#a69;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=lead][shape=circle] i{border-radius:50%}:host[theme=contact] i{color:#fff;background:#fa4;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=contact][shape=circle] i{border-radius:50%}:host[theme=clientcontact] i{color:#fff;background:#fa4;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=clientcontact][shape=circle] i{border-radius:50%}:host[theme=opportunity] i{color:#fff;background:#625;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=opportunity][shape=circle] i{border-radius:50%}:host[theme=job] i{color:#fff;background:#b56;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=job][shape=circle] i{border-radius:50%}:host[theme=joborder] i{color:#fff;background:#b56;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=joborder][shape=circle] i{border-radius:50%}:host[theme=submission] i{color:#fff;background:#a9adbb;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=submission][shape=circle] i{border-radius:50%}:host[theme=sendout] i{color:#fff;background:#747884;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=sendout][shape=circle] i{border-radius:50%}:host[theme=placement] i{color:#fff;background:#0b344f;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=placement][shape=circle] i{border-radius:50%}:host[theme=note] i{color:#fff;background:#747884;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=note][shape=circle] i{border-radius:50%}:host[theme=contract] i{color:#fff;background:#454ea0;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=contract][shape=circle] i{border-radius:50%}:host[theme=jobCode] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=jobCode][shape=circle] i{border-radius:50%}:host[theme=earnCode] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=earnCode][shape=circle] i{border-radius:50%}:host[theme=invoiceStatement] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=invoiceStatement][shape=circle] i{border-radius:50%}:host[theme=billableCharge] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=billableCharge][shape=circle] i{border-radius:50%}:host[theme=payableCharge] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=payableCharge][shape=circle] i{border-radius:50%}:host[theme=user] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=user][shape=circle] i{border-radius:50%}:host[theme=corporateUser] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=corporateUser][shape=circle] i{border-radius:50%}:host[theme=distributionList] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=distributionList][shape=circle] i{border-radius:50%}:host[theme=credential] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=credential][shape=circle] i{border-radius:50%}:host[theme=person] i{color:#fff;background:#696d79;border-radius:.3em;width:1.6em;height:1.6em}:host[theme=person][shape=circle] i{border-radius:50%}:host.novo-icon-raised i{box-shadow:2px 2px #0003}:host[shape=circle] i{border-radius:50%}:host.icon-size-smaller{font-size:1em}:host.icon-size-larger{font-size:1.4em}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i0.ChangeDetectorRef }], propDecorators: { raised: [{
                type: HostBinding,
                args: ['class.novo-icon-raised']
            }, {
                type: Input
            }], theme: [{
                type: HostBinding,
                args: ['attr.theme']
            }, {
                type: Input
            }], shape: [{
                type: HostBinding,
                args: ['attr.shape']
            }, {
                type: Input
            }], color: [{
                type: Input
            }], role: [{
                type: HostBinding,
                args: ['attr.role']
            }], ariaLabel: [{
                type: HostBinding,
                args: ['attr.aria-label']
            }], size: [{
                type: Input
            }], smaller: [{
                type: HostBinding,
                args: ['class.icon-size-smaller']
            }, {
                type: Input
            }], larger: [{
                type: HostBinding,
                args: ['class.icon-size-larger']
            }, {
                type: Input
            }], alt: [{
                type: Input
            }], name: [{
                type: Input
            }], hb_classBinding: [{
                type: HostBinding,
                args: ['class']
            }] } });

class NovoIconModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoIconModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: NovoIconModule, declarations: [NovoIconComponent], imports: [ObserversModule], exports: [NovoIconComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoIconModule, imports: [ObserversModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoIconModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [ObserversModule],
                    exports: [NovoIconComponent],
                    declarations: [NovoIconComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NovoIconComponent, NovoIconModule };
//# sourceMappingURL=novo-elements-elements-icon.mjs.map
