import * as i0 from '@angular/core';
import { Component, Input, NgModule } from '@angular/core';
import * as i1 from 'novo-elements/services';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from 'novo-elements/elements/button';
import { NovoButtonModule } from 'novo-elements/elements/button';

// NG2
class NovoSliderElement {
    constructor(element, labels) {
        this.element = element;
        this.labels = labels;
        this.currentSlide = 0;
        this.start = true;
        this.end = true;
        this.currSlides = ['active'];
        this.handleKeyDownFunc = this.handleKeyDown.bind(this);
    }
    ngOnInit() {
        for (let i = 0; i < this.slides; i++) {
            this.currSlides[i] = i > 0 ? 'inactive' : 'active';
        }
        // Catch Tab Events
        this.element.nativeElement.addEventListener('keydown', this.handleKeyDownFunc);
    }
    ngOnDestroy() {
        this.element.nativeElement.removeEventListener('keydown', this.handleKeyDownFunc);
    }
    handleKeyDown(event) {
        if (event.key === "Tab" /* Key.Tab */) {
            event.stopImmediatePropagation();
            event.preventDefault();
        }
    }
    changeSlide(direction) {
        if (direction === 'next') {
            if (this.currentSlide === this.slides - 1) {
                return;
            }
            this.currentSlide++;
        }
        else {
            if (this.currentSlide === 0) {
                return;
            }
            this.currentSlide--;
        }
        for (let i = 0; i < this.slides; i++) {
            this.currSlides[i] = 'inactive';
        }
        this.currSlides[this.currentSlide] = 'active';
        this.start = this.currentSlide === 0;
        this.end = this.currentSlide === this.slides - 1;
        this.currentClass = `slide-${this.currentSlide}`;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoSliderElement, deps: [{ token: i0.ElementRef }, { token: i1.NovoLabelService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: NovoSliderElement, selector: "novo-slider", inputs: { slides: "slides" }, host: { properties: { "class": "currentClass" } }, ngImport: i0, template: `
    <section class="slides">
      <ng-content select="div[slide]"></ng-content>
    </section>
    <div class="controls">
      <button *ngIf="!start" theme="icon" icon="previous" (click)="changeSlide('back')"></button>
      <div class="indicators">
        <div class="indicator-circle" *ngFor="let indicator of currSlides; let i = index" [ngClass]="indicator"></div>
      </div>
      <button *ngIf="!end" theme="primary" icon="next" (click)="changeSlide('next')">{{ labels.next }}</button>
      <ng-content select="button" *ngIf="end"></ng-content>
    </div>
  `, isInline: true, styles: [":host{display:block;width:100%;max-width:1000px;margin:0 auto;position:relative;overflow:hidden}:host>[slide=\"0\"]{left:0%}:host.slide-0 .slides{transform:translate(0)}:host>[slide=\"1\"]{left:100%}:host.slide-1 .slides{transform:translate(-100%)}:host>[slide=\"2\"]{left:200%}:host.slide-2 .slides{transform:translate(-200%)}:host>[slide=\"3\"]{left:300%}:host.slide-3 .slides{transform:translate(-300%)}:host>[slide=\"4\"]{left:400%}:host.slide-4 .slides{transform:translate(-400%)}:host>[slide=\"5\"]{left:500%}:host.slide-5 .slides{transform:translate(-500%)}:host>[slide=\"6\"]{left:600%}:host.slide-6 .slides{transform:translate(-600%)}:host>[slide=\"7\"]{left:700%}:host.slide-7 .slides{transform:translate(-700%)}:host>[slide=\"8\"]{left:800%}:host.slide-8 .slides{transform:translate(-800%)}:host>[slide=\"9\"]{left:900%}:host.slide-9 .slides{transform:translate(-900%)}:host>[slide=\"10\"]{left:1000%}:host.slide-10 .slides{transform:translate(-1000%)}:host>[slide=\"11\"]{left:1100%}:host.slide-11 .slides{transform:translate(-1100%)}:host>[slide=\"12\"]{left:1200%}:host.slide-12 .slides{transform:translate(-1200%)}:host>[slide=\"13\"]{left:1300%}:host.slide-13 .slides{transform:translate(-1300%)}:host>[slide=\"14\"]{left:1400%}:host.slide-14 .slides{transform:translate(-1400%)}:host>[slide=\"15\"]{left:1500%}:host.slide-15 .slides{transform:translate(-1500%)}:host>[slide=\"16\"]{left:1600%}:host.slide-16 .slides{transform:translate(-1600%)}:host>[slide=\"17\"]{left:1700%}:host.slide-17 .slides{transform:translate(-1700%)}:host>[slide=\"18\"]{left:1800%}:host.slide-18 .slides{transform:translate(-1800%)}:host>[slide=\"19\"]{left:1900%}:host.slide-19 .slides{transform:translate(-1900%)}:host>[slide=\"20\"]{left:2000%}:host.slide-20 .slides{transform:translate(-2000%)}:host>[slide=\"21\"]{left:2100%}:host.slide-21 .slides{transform:translate(-2100%)}:host>[slide=\"22\"]{left:2200%}:host.slide-22 .slides{transform:translate(-2200%)}:host>[slide=\"23\"]{left:2300%}:host.slide-23 .slides{transform:translate(-2300%)}:host>[slide=\"24\"]{left:2400%}:host.slide-24 .slides{transform:translate(-2400%)}:host>[slide=\"25\"]{left:2500%}:host.slide-25 .slides{transform:translate(-2500%)}:host>[slide=\"26\"]{left:2600%}:host.slide-26 .slides{transform:translate(-2600%)}:host>[slide=\"27\"]{left:2700%}:host.slide-27 .slides{transform:translate(-2700%)}:host>[slide=\"28\"]{left:2800%}:host.slide-28 .slides{transform:translate(-2800%)}:host>[slide=\"29\"]{left:2900%}:host.slide-29 .slides{transform:translate(-2900%)}:host>[slide=\"30\"]{left:3000%}:host.slide-30 .slides{transform:translate(-3000%)}:host>[slide=\"31\"]{left:3100%}:host.slide-31 .slides{transform:translate(-3100%)}:host>[slide=\"32\"]{left:3200%}:host.slide-32 .slides{transform:translate(-3200%)}:host>[slide=\"33\"]{left:3300%}:host.slide-33 .slides{transform:translate(-3300%)}:host>[slide=\"34\"]{left:3400%}:host.slide-34 .slides{transform:translate(-3400%)}:host>[slide=\"35\"]{left:3500%}:host.slide-35 .slides{transform:translate(-3500%)}:host>[slide=\"36\"]{left:3600%}:host.slide-36 .slides{transform:translate(-3600%)}:host>[slide=\"37\"]{left:3700%}:host.slide-37 .slides{transform:translate(-3700%)}:host>[slide=\"38\"]{left:3800%}:host.slide-38 .slides{transform:translate(-3800%)}:host>[slide=\"39\"]{left:3900%}:host.slide-39 .slides{transform:translate(-3900%)}:host>[slide=\"40\"]{left:4000%}:host.slide-40 .slides{transform:translate(-4000%)}:host>[slide=\"41\"]{left:4100%}:host.slide-41 .slides{transform:translate(-4100%)}:host>[slide=\"42\"]{left:4200%}:host.slide-42 .slides{transform:translate(-4200%)}:host>[slide=\"43\"]{left:4300%}:host.slide-43 .slides{transform:translate(-4300%)}:host>[slide=\"44\"]{left:4400%}:host.slide-44 .slides{transform:translate(-4400%)}:host>[slide=\"45\"]{left:4500%}:host.slide-45 .slides{transform:translate(-4500%)}:host>[slide=\"46\"]{left:4600%}:host.slide-46 .slides{transform:translate(-4600%)}:host>[slide=\"47\"]{left:4700%}:host.slide-47 .slides{transform:translate(-4700%)}:host>[slide=\"48\"]{left:4800%}:host.slide-48 .slides{transform:translate(-4800%)}:host>[slide=\"49\"]{left:4900%}:host.slide-49 .slides{transform:translate(-4900%)}:host>[slide=\"50\"]{left:5000%}:host.slide-50 .slides{transform:translate(-5000%)}:host>[slide=\"51\"]{left:5100%}:host.slide-51 .slides{transform:translate(-5100%)}:host>[slide=\"52\"]{left:5200%}:host.slide-52 .slides{transform:translate(-5200%)}:host>[slide=\"53\"]{left:5300%}:host.slide-53 .slides{transform:translate(-5300%)}:host>[slide=\"54\"]{left:5400%}:host.slide-54 .slides{transform:translate(-5400%)}:host>[slide=\"55\"]{left:5500%}:host.slide-55 .slides{transform:translate(-5500%)}:host>[slide=\"56\"]{left:5600%}:host.slide-56 .slides{transform:translate(-5600%)}:host>[slide=\"57\"]{left:5700%}:host.slide-57 .slides{transform:translate(-5700%)}:host>[slide=\"58\"]{left:5800%}:host.slide-58 .slides{transform:translate(-5800%)}:host>[slide=\"59\"]{left:5900%}:host.slide-59 .slides{transform:translate(-5900%)}:host>[slide=\"60\"]{left:6000%}:host.slide-60 .slides{transform:translate(-6000%)}:host>[slide=\"61\"]{left:6100%}:host.slide-61 .slides{transform:translate(-6100%)}:host>[slide=\"62\"]{left:6200%}:host.slide-62 .slides{transform:translate(-6200%)}:host>[slide=\"63\"]{left:6300%}:host.slide-63 .slides{transform:translate(-6300%)}:host>[slide=\"64\"]{left:6400%}:host.slide-64 .slides{transform:translate(-6400%)}:host>[slide=\"65\"]{left:6500%}:host.slide-65 .slides{transform:translate(-6500%)}:host>[slide=\"66\"]{left:6600%}:host.slide-66 .slides{transform:translate(-6600%)}:host>[slide=\"67\"]{left:6700%}:host.slide-67 .slides{transform:translate(-6700%)}:host>[slide=\"68\"]{left:6800%}:host.slide-68 .slides{transform:translate(-6800%)}:host>[slide=\"69\"]{left:6900%}:host.slide-69 .slides{transform:translate(-6900%)}:host>[slide=\"70\"]{left:7000%}:host.slide-70 .slides{transform:translate(-7000%)}:host>[slide=\"71\"]{left:7100%}:host.slide-71 .slides{transform:translate(-7100%)}:host>[slide=\"72\"]{left:7200%}:host.slide-72 .slides{transform:translate(-7200%)}:host>[slide=\"73\"]{left:7300%}:host.slide-73 .slides{transform:translate(-7300%)}:host>[slide=\"74\"]{left:7400%}:host.slide-74 .slides{transform:translate(-7400%)}:host>[slide=\"75\"]{left:7500%}:host.slide-75 .slides{transform:translate(-7500%)}:host>[slide=\"76\"]{left:7600%}:host.slide-76 .slides{transform:translate(-7600%)}:host>[slide=\"77\"]{left:7700%}:host.slide-77 .slides{transform:translate(-7700%)}:host>[slide=\"78\"]{left:7800%}:host.slide-78 .slides{transform:translate(-7800%)}:host>[slide=\"79\"]{left:7900%}:host.slide-79 .slides{transform:translate(-7900%)}:host>[slide=\"80\"]{left:8000%}:host.slide-80 .slides{transform:translate(-8000%)}:host>[slide=\"81\"]{left:8100%}:host.slide-81 .slides{transform:translate(-8100%)}:host>[slide=\"82\"]{left:8200%}:host.slide-82 .slides{transform:translate(-8200%)}:host>[slide=\"83\"]{left:8300%}:host.slide-83 .slides{transform:translate(-8300%)}:host>[slide=\"84\"]{left:8400%}:host.slide-84 .slides{transform:translate(-8400%)}:host>[slide=\"85\"]{left:8500%}:host.slide-85 .slides{transform:translate(-8500%)}:host>[slide=\"86\"]{left:8600%}:host.slide-86 .slides{transform:translate(-8600%)}:host>[slide=\"87\"]{left:8700%}:host.slide-87 .slides{transform:translate(-8700%)}:host>[slide=\"88\"]{left:8800%}:host.slide-88 .slides{transform:translate(-8800%)}:host>[slide=\"89\"]{left:8900%}:host.slide-89 .slides{transform:translate(-8900%)}:host>[slide=\"90\"]{left:9000%}:host.slide-90 .slides{transform:translate(-9000%)}:host>[slide=\"91\"]{left:9100%}:host.slide-91 .slides{transform:translate(-9100%)}:host>[slide=\"92\"]{left:9200%}:host.slide-92 .slides{transform:translate(-9200%)}:host>[slide=\"93\"]{left:9300%}:host.slide-93 .slides{transform:translate(-9300%)}:host>[slide=\"94\"]{left:9400%}:host.slide-94 .slides{transform:translate(-9400%)}:host>[slide=\"95\"]{left:9500%}:host.slide-95 .slides{transform:translate(-9500%)}:host>[slide=\"96\"]{left:9600%}:host.slide-96 .slides{transform:translate(-9600%)}:host>[slide=\"97\"]{left:9700%}:host.slide-97 .slides{transform:translate(-9700%)}:host>[slide=\"98\"]{left:9800%}:host.slide-98 .slides{transform:translate(-9800%)}:host>[slide=\"99\"]{left:9900%}:host.slide-99 .slides{transform:translate(-9900%)}:host>[slide=\"100\"]{left:10000%}:host.slide-100 .slides{transform:translate(-10000%)}:host .slides{min-height:250px;transition:all .2s ease-in-out;width:100%;display:flex;flex:1 0 100%}:host .slides>::ng-deep [slide]{display:flex;flex:1 0 100%;justify-content:center;align-items:center;flex-wrap:wrap;flex-direction:column}:host .slides img{display:block;margin:auto}:host .controls{width:100%;position:absolute;bottom:10px}:host .controls button{position:absolute;top:50%;transform:translateY(-50%)}:host .controls button[icon=previous]{left:10px}:host .controls button[icon=next],:host .controls button[icon=check]{right:10px}:host .indicators{display:flex;flex-direction:row;align-items:center;justify-content:center;width:100%;background:#ffffff0d;padding:20px}:host .indicators .indicator-circle{width:8px;height:8px;margin:0 5px;border-radius:50%;background:#d8d8d8;opacity:.2;transition:all .2s ease-in-out}:host .indicators .indicator-circle.active{opacity:1}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i3.NovoButtonElement, selector: "novo-button,button[theme]", inputs: ["color", "side", "size", "theme", "loading", "icon", "secondIcon", "disabled"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoSliderElement, decorators: [{
            type: Component,
            args: [{ selector: 'novo-slider', template: `
    <section class="slides">
      <ng-content select="div[slide]"></ng-content>
    </section>
    <div class="controls">
      <button *ngIf="!start" theme="icon" icon="previous" (click)="changeSlide('back')"></button>
      <div class="indicators">
        <div class="indicator-circle" *ngFor="let indicator of currSlides; let i = index" [ngClass]="indicator"></div>
      </div>
      <button *ngIf="!end" theme="primary" icon="next" (click)="changeSlide('next')">{{ labels.next }}</button>
      <ng-content select="button" *ngIf="end"></ng-content>
    </div>
  `, host: {
                        '[class]': 'currentClass',
                    }, styles: [":host{display:block;width:100%;max-width:1000px;margin:0 auto;position:relative;overflow:hidden}:host>[slide=\"0\"]{left:0%}:host.slide-0 .slides{transform:translate(0)}:host>[slide=\"1\"]{left:100%}:host.slide-1 .slides{transform:translate(-100%)}:host>[slide=\"2\"]{left:200%}:host.slide-2 .slides{transform:translate(-200%)}:host>[slide=\"3\"]{left:300%}:host.slide-3 .slides{transform:translate(-300%)}:host>[slide=\"4\"]{left:400%}:host.slide-4 .slides{transform:translate(-400%)}:host>[slide=\"5\"]{left:500%}:host.slide-5 .slides{transform:translate(-500%)}:host>[slide=\"6\"]{left:600%}:host.slide-6 .slides{transform:translate(-600%)}:host>[slide=\"7\"]{left:700%}:host.slide-7 .slides{transform:translate(-700%)}:host>[slide=\"8\"]{left:800%}:host.slide-8 .slides{transform:translate(-800%)}:host>[slide=\"9\"]{left:900%}:host.slide-9 .slides{transform:translate(-900%)}:host>[slide=\"10\"]{left:1000%}:host.slide-10 .slides{transform:translate(-1000%)}:host>[slide=\"11\"]{left:1100%}:host.slide-11 .slides{transform:translate(-1100%)}:host>[slide=\"12\"]{left:1200%}:host.slide-12 .slides{transform:translate(-1200%)}:host>[slide=\"13\"]{left:1300%}:host.slide-13 .slides{transform:translate(-1300%)}:host>[slide=\"14\"]{left:1400%}:host.slide-14 .slides{transform:translate(-1400%)}:host>[slide=\"15\"]{left:1500%}:host.slide-15 .slides{transform:translate(-1500%)}:host>[slide=\"16\"]{left:1600%}:host.slide-16 .slides{transform:translate(-1600%)}:host>[slide=\"17\"]{left:1700%}:host.slide-17 .slides{transform:translate(-1700%)}:host>[slide=\"18\"]{left:1800%}:host.slide-18 .slides{transform:translate(-1800%)}:host>[slide=\"19\"]{left:1900%}:host.slide-19 .slides{transform:translate(-1900%)}:host>[slide=\"20\"]{left:2000%}:host.slide-20 .slides{transform:translate(-2000%)}:host>[slide=\"21\"]{left:2100%}:host.slide-21 .slides{transform:translate(-2100%)}:host>[slide=\"22\"]{left:2200%}:host.slide-22 .slides{transform:translate(-2200%)}:host>[slide=\"23\"]{left:2300%}:host.slide-23 .slides{transform:translate(-2300%)}:host>[slide=\"24\"]{left:2400%}:host.slide-24 .slides{transform:translate(-2400%)}:host>[slide=\"25\"]{left:2500%}:host.slide-25 .slides{transform:translate(-2500%)}:host>[slide=\"26\"]{left:2600%}:host.slide-26 .slides{transform:translate(-2600%)}:host>[slide=\"27\"]{left:2700%}:host.slide-27 .slides{transform:translate(-2700%)}:host>[slide=\"28\"]{left:2800%}:host.slide-28 .slides{transform:translate(-2800%)}:host>[slide=\"29\"]{left:2900%}:host.slide-29 .slides{transform:translate(-2900%)}:host>[slide=\"30\"]{left:3000%}:host.slide-30 .slides{transform:translate(-3000%)}:host>[slide=\"31\"]{left:3100%}:host.slide-31 .slides{transform:translate(-3100%)}:host>[slide=\"32\"]{left:3200%}:host.slide-32 .slides{transform:translate(-3200%)}:host>[slide=\"33\"]{left:3300%}:host.slide-33 .slides{transform:translate(-3300%)}:host>[slide=\"34\"]{left:3400%}:host.slide-34 .slides{transform:translate(-3400%)}:host>[slide=\"35\"]{left:3500%}:host.slide-35 .slides{transform:translate(-3500%)}:host>[slide=\"36\"]{left:3600%}:host.slide-36 .slides{transform:translate(-3600%)}:host>[slide=\"37\"]{left:3700%}:host.slide-37 .slides{transform:translate(-3700%)}:host>[slide=\"38\"]{left:3800%}:host.slide-38 .slides{transform:translate(-3800%)}:host>[slide=\"39\"]{left:3900%}:host.slide-39 .slides{transform:translate(-3900%)}:host>[slide=\"40\"]{left:4000%}:host.slide-40 .slides{transform:translate(-4000%)}:host>[slide=\"41\"]{left:4100%}:host.slide-41 .slides{transform:translate(-4100%)}:host>[slide=\"42\"]{left:4200%}:host.slide-42 .slides{transform:translate(-4200%)}:host>[slide=\"43\"]{left:4300%}:host.slide-43 .slides{transform:translate(-4300%)}:host>[slide=\"44\"]{left:4400%}:host.slide-44 .slides{transform:translate(-4400%)}:host>[slide=\"45\"]{left:4500%}:host.slide-45 .slides{transform:translate(-4500%)}:host>[slide=\"46\"]{left:4600%}:host.slide-46 .slides{transform:translate(-4600%)}:host>[slide=\"47\"]{left:4700%}:host.slide-47 .slides{transform:translate(-4700%)}:host>[slide=\"48\"]{left:4800%}:host.slide-48 .slides{transform:translate(-4800%)}:host>[slide=\"49\"]{left:4900%}:host.slide-49 .slides{transform:translate(-4900%)}:host>[slide=\"50\"]{left:5000%}:host.slide-50 .slides{transform:translate(-5000%)}:host>[slide=\"51\"]{left:5100%}:host.slide-51 .slides{transform:translate(-5100%)}:host>[slide=\"52\"]{left:5200%}:host.slide-52 .slides{transform:translate(-5200%)}:host>[slide=\"53\"]{left:5300%}:host.slide-53 .slides{transform:translate(-5300%)}:host>[slide=\"54\"]{left:5400%}:host.slide-54 .slides{transform:translate(-5400%)}:host>[slide=\"55\"]{left:5500%}:host.slide-55 .slides{transform:translate(-5500%)}:host>[slide=\"56\"]{left:5600%}:host.slide-56 .slides{transform:translate(-5600%)}:host>[slide=\"57\"]{left:5700%}:host.slide-57 .slides{transform:translate(-5700%)}:host>[slide=\"58\"]{left:5800%}:host.slide-58 .slides{transform:translate(-5800%)}:host>[slide=\"59\"]{left:5900%}:host.slide-59 .slides{transform:translate(-5900%)}:host>[slide=\"60\"]{left:6000%}:host.slide-60 .slides{transform:translate(-6000%)}:host>[slide=\"61\"]{left:6100%}:host.slide-61 .slides{transform:translate(-6100%)}:host>[slide=\"62\"]{left:6200%}:host.slide-62 .slides{transform:translate(-6200%)}:host>[slide=\"63\"]{left:6300%}:host.slide-63 .slides{transform:translate(-6300%)}:host>[slide=\"64\"]{left:6400%}:host.slide-64 .slides{transform:translate(-6400%)}:host>[slide=\"65\"]{left:6500%}:host.slide-65 .slides{transform:translate(-6500%)}:host>[slide=\"66\"]{left:6600%}:host.slide-66 .slides{transform:translate(-6600%)}:host>[slide=\"67\"]{left:6700%}:host.slide-67 .slides{transform:translate(-6700%)}:host>[slide=\"68\"]{left:6800%}:host.slide-68 .slides{transform:translate(-6800%)}:host>[slide=\"69\"]{left:6900%}:host.slide-69 .slides{transform:translate(-6900%)}:host>[slide=\"70\"]{left:7000%}:host.slide-70 .slides{transform:translate(-7000%)}:host>[slide=\"71\"]{left:7100%}:host.slide-71 .slides{transform:translate(-7100%)}:host>[slide=\"72\"]{left:7200%}:host.slide-72 .slides{transform:translate(-7200%)}:host>[slide=\"73\"]{left:7300%}:host.slide-73 .slides{transform:translate(-7300%)}:host>[slide=\"74\"]{left:7400%}:host.slide-74 .slides{transform:translate(-7400%)}:host>[slide=\"75\"]{left:7500%}:host.slide-75 .slides{transform:translate(-7500%)}:host>[slide=\"76\"]{left:7600%}:host.slide-76 .slides{transform:translate(-7600%)}:host>[slide=\"77\"]{left:7700%}:host.slide-77 .slides{transform:translate(-7700%)}:host>[slide=\"78\"]{left:7800%}:host.slide-78 .slides{transform:translate(-7800%)}:host>[slide=\"79\"]{left:7900%}:host.slide-79 .slides{transform:translate(-7900%)}:host>[slide=\"80\"]{left:8000%}:host.slide-80 .slides{transform:translate(-8000%)}:host>[slide=\"81\"]{left:8100%}:host.slide-81 .slides{transform:translate(-8100%)}:host>[slide=\"82\"]{left:8200%}:host.slide-82 .slides{transform:translate(-8200%)}:host>[slide=\"83\"]{left:8300%}:host.slide-83 .slides{transform:translate(-8300%)}:host>[slide=\"84\"]{left:8400%}:host.slide-84 .slides{transform:translate(-8400%)}:host>[slide=\"85\"]{left:8500%}:host.slide-85 .slides{transform:translate(-8500%)}:host>[slide=\"86\"]{left:8600%}:host.slide-86 .slides{transform:translate(-8600%)}:host>[slide=\"87\"]{left:8700%}:host.slide-87 .slides{transform:translate(-8700%)}:host>[slide=\"88\"]{left:8800%}:host.slide-88 .slides{transform:translate(-8800%)}:host>[slide=\"89\"]{left:8900%}:host.slide-89 .slides{transform:translate(-8900%)}:host>[slide=\"90\"]{left:9000%}:host.slide-90 .slides{transform:translate(-9000%)}:host>[slide=\"91\"]{left:9100%}:host.slide-91 .slides{transform:translate(-9100%)}:host>[slide=\"92\"]{left:9200%}:host.slide-92 .slides{transform:translate(-9200%)}:host>[slide=\"93\"]{left:9300%}:host.slide-93 .slides{transform:translate(-9300%)}:host>[slide=\"94\"]{left:9400%}:host.slide-94 .slides{transform:translate(-9400%)}:host>[slide=\"95\"]{left:9500%}:host.slide-95 .slides{transform:translate(-9500%)}:host>[slide=\"96\"]{left:9600%}:host.slide-96 .slides{transform:translate(-9600%)}:host>[slide=\"97\"]{left:9700%}:host.slide-97 .slides{transform:translate(-9700%)}:host>[slide=\"98\"]{left:9800%}:host.slide-98 .slides{transform:translate(-9800%)}:host>[slide=\"99\"]{left:9900%}:host.slide-99 .slides{transform:translate(-9900%)}:host>[slide=\"100\"]{left:10000%}:host.slide-100 .slides{transform:translate(-10000%)}:host .slides{min-height:250px;transition:all .2s ease-in-out;width:100%;display:flex;flex:1 0 100%}:host .slides>::ng-deep [slide]{display:flex;flex:1 0 100%;justify-content:center;align-items:center;flex-wrap:wrap;flex-direction:column}:host .slides img{display:block;margin:auto}:host .controls{width:100%;position:absolute;bottom:10px}:host .controls button{position:absolute;top:50%;transform:translateY(-50%)}:host .controls button[icon=previous]{left:10px}:host .controls button[icon=next],:host .controls button[icon=check]{right:10px}:host .indicators{display:flex;flex-direction:row;align-items:center;justify-content:center;width:100%;background:#ffffff0d;padding:20px}:host .indicators .indicator-circle{width:8px;height:8px;margin:0 5px;border-radius:50%;background:#d8d8d8;opacity:.2;transition:all .2s ease-in-out}:host .indicators .indicator-circle.active{opacity:1}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }, { type: i1.NovoLabelService }], propDecorators: { slides: [{
                type: Input
            }] } });

// NG2
class NovoSliderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoSliderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: NovoSliderModule, declarations: [NovoSliderElement], imports: [CommonModule, NovoButtonModule], exports: [NovoSliderElement] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoSliderModule, imports: [CommonModule, NovoButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoSliderModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, NovoButtonModule],
                    declarations: [NovoSliderElement],
                    exports: [NovoSliderElement],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NovoSliderElement, NovoSliderModule };
//# sourceMappingURL=novo-elements-elements-slider.mjs.map
