import * as i0 from '@angular/core';
import { Injectable, InjectionToken, EventEmitter, Component, ChangeDetectionStrategy, Inject, Input, Output, NgModule } from '@angular/core';
import * as i1 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from 'novo-elements/elements/dropdown';
import { NovoDropdownModule } from 'novo-elements/elements/dropdown';
import * as i4 from 'novo-elements/elements/search';
import { NovoSearchBoxModule } from 'novo-elements/elements/search';
import * as i5 from 'novo-elements/elements/button';
import { NovoButtonModule } from 'novo-elements/elements/button';
import * as i6 from 'novo-elements/elements/common';
import { NovoOptionModule } from 'novo-elements/elements/common';
import { NovoIconModule } from 'novo-elements/elements/icon';

class BreadcrumbService {
    constructor(router) {
        this.router = router;
    }
    navigateTo($event, item) {
        if ($event.button !== 0 || $event.ctrlKey || $event.metaKey || $event.shiftKey) {
            return;
        }
        if (typeof item.target === 'string' && item.target !== '_self') {
            return;
        }
        $event.preventDefault();
        this.router.navigateByUrl(item.link);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbService, deps: [{ token: i1.Router }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbService, decorators: [{
            type: Injectable
        }], ctorParameters: () => [{ type: i1.Router }] });

/**
 * Injection token used to provide the parent component to options.
 */
const NOVO_BREADCRUMB_REF = new InjectionToken('NOVO_BREADCRUMB_REF');

class BreadcrumbItemElement {
    constructor(breadcrumbService, breadcrumbComponent) {
        this.breadcrumbService = breadcrumbService;
        this.breadcrumbComponent = breadcrumbComponent;
        this.showMenu = false;
        this.isSearch = false;
        this.toggleEvent = new EventEmitter();
    }
    ngOnInit() {
        this.menuListDisplay = this.menuList;
    }
    onToggle($event) {
        this.isOpen = $event;
        this.toggleEvent.emit($event);
    }
    searchEvent($event) {
        if (this.menuList) {
            this.menuListDisplay = this.menuList.filter((item) => item.name.toLowerCase().includes($event.toLowerCase()));
        }
    }
    navigateTo($event, item) {
        this.breadcrumbService.navigateTo($event, item);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbItemElement, deps: [{ token: BreadcrumbService }, { token: NOVO_BREADCRUMB_REF }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: BreadcrumbItemElement, selector: "novo-breadcrumb-item", inputs: { showMenu: "showMenu", customMenuTemplate: "customMenuTemplate", menuList: "menuList", isSearch: "isSearch" }, outputs: { toggleEvent: "toggleEvent" }, ngImport: i0, template: "<ng-container *ngIf=\"showMenu; else breadcrumbContentTpl\">\n  <span [ngClass]=\"{ 'novo-breadcrumb-item-active': isOpen }\" #origin\n    class=\"novo-dropdown-no-border novo-dropdown-origin novo-breadcrumb-dropdown-origin\">\n    <ng-template [ngTemplateOutlet]=\"breadcrumbContentTpl\"></ng-template>\n    <novo-dropdown>\n      <novo-button theme=\"icon\" icon=\"collapse\" size=\"small\"></novo-button>\n      <novo-optgroup class=\"novo-breadcrumb-dropdown-menu\">\n        <div *ngIf=\"isSearch\" class=\"dropdown-search-container\">\n          <novo-search alwaysOpen=\"true\" (searchFn)=\"searchEvent($event)\" [class]=\"'search-in-dropdown'\"></novo-search>\n        </div>\n        <novo-option *ngFor=\"let item of menuListDisplay\" title=\"{{ item.name }}\">\n          <a *ngIf=\"!item.linkType || item.linkType === 'hrefLink'\" [href]=\"item.link\" rel=\"noopener\"\n            [target]=\"item.target ? item.target : '_self'\">{{ item.name }}</a>\n          <a *ngIf=\"item.linkType === 'routerLink'\" rel=\"noopener\" [target]=\"item.target\" [href]=\"item.link\"\n            (click)=\"navigateTo($event, item)\">{{ item.name }}</a>\n        </novo-option>\n      </novo-optgroup>\n    </novo-dropdown>\n  </span>\n</ng-container>\n\n<ng-template #breadcrumbContentTpl>\n  <span class=\"novo-breadcrumb-item\">\n    <ng-content></ng-content>\n  </span>\n</ng-template>\n\n<ng-template #dropDownMenuTpl>\n  <div>test</div>\n\n</ng-template>\n\n<span class=\"novo-breadcrumb-separator\">\n  <ng-template\n    [ngTemplateOutlet]=\"breadcrumbComponent.separatorIcon ? breadcrumbComponent.separatorIcon : defaultSeparator\"\n    [ngTemplateOutletContext]=\"{\n    $implicit: this\n  }\">\n  </ng-template>\n</span>\n\n<ng-template #defaultSeparator>\n  <span class=\"novo-breadcrumb-separator\">\n    /\n  </span>\n</ng-template>", styles: [".novo-breadcrumb-font-style,:host .novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a,:host .novo-breadcrumb-item{display:inline;font-weight:400;color:inherit;font-size:var(--font-size-text);transition:color .2s ease-out,opacity .2s ease-out;vertical-align:middle}.novo-breadcrumb-font-style.text-capitalize,:host .text-capitalize.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-capitalize,:host .text-capitalize.novo-breadcrumb-item{text-transform:capitalize}.novo-breadcrumb-font-style.text-uppercase,:host .text-uppercase.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-uppercase,:host .text-uppercase.novo-breadcrumb-item{text-transform:uppercase}.novo-breadcrumb-font-style.text-nowrap,:host .text-nowrap.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-nowrap,:host .text-nowrap.novo-breadcrumb-item{white-space:nowrap}.novo-breadcrumb-font-style.text-ellipsis,:host .text-ellipsis.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-ellipsis,:host .text-ellipsis.novo-breadcrumb-item{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.novo-breadcrumb-font-style.text-size-default,:host .text-size-default.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-default,:host .text-size-default.novo-breadcrumb-item{font-size:inherit}.novo-breadcrumb-font-style.text-size-body,:host .text-size-body.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-body,:host .text-size-body.novo-breadcrumb-item{font-size:1.3rem}.novo-breadcrumb-font-style.text-size-xs,:host .text-size-xs.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-xs,:host .text-size-xs.novo-breadcrumb-item{font-size:1rem}.novo-breadcrumb-font-style.text-size-sm,:host .text-size-sm.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-sm,:host .text-size-sm.novo-breadcrumb-item{font-size:1.2rem}.novo-breadcrumb-font-style.text-size-md,:host .text-size-md.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-md,:host .text-size-md.novo-breadcrumb-item{font-size:1.3rem}.novo-breadcrumb-font-style.text-size-lg,:host .text-size-lg.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-lg,:host .text-size-lg.novo-breadcrumb-item{font-size:1.6rem}.novo-breadcrumb-font-style.text-size-xl,:host .text-size-xl.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-xl,:host .text-size-xl.novo-breadcrumb-item{font-size:2rem}.novo-breadcrumb-font-style.text-size-2xl,:host .text-size-2xl.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-2xl,:host .text-size-2xl.novo-breadcrumb-item{font-size:2.6rem}.novo-breadcrumb-font-style.text-size-3xl,:host .text-size-3xl.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-3xl,:host .text-size-3xl.novo-breadcrumb-item{font-size:3.2rem}.novo-breadcrumb-font-style.text-size-smaller,:host .text-size-smaller.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-smaller,:host .text-size-smaller.novo-breadcrumb-item{font-size:.8em}.novo-breadcrumb-font-style.text-size-larger,:host .text-size-larger.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-larger,:host .text-size-larger.novo-breadcrumb-item{font-size:1.2em}.novo-breadcrumb-font-style.text-color-black,:host .text-color-black.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-black,:host .text-color-black.novo-breadcrumb-item{color:#000}.novo-breadcrumb-font-style.text-color-white,:host .text-color-white.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-white,:host .text-color-white.novo-breadcrumb-item{color:#fff}.novo-breadcrumb-font-style.text-color-gray,:host .text-color-gray.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-gray,:host .text-color-gray.novo-breadcrumb-item{color:#9e9e9e}.novo-breadcrumb-font-style.text-color-grey,:host .text-color-grey.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-grey,:host .text-color-grey.novo-breadcrumb-item{color:#9e9e9e}.novo-breadcrumb-font-style.text-color-offWhite,:host .text-color-offWhite.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-offWhite,:host .text-color-offWhite.novo-breadcrumb-item{color:#f7f7f7}.novo-breadcrumb-font-style.text-color-bright,:host .text-color-bright.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-bright,:host .text-color-bright.novo-breadcrumb-item{color:#f7f7f7}.novo-breadcrumb-font-style.text-color-light,:host .text-color-light.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-light,:host .text-color-light.novo-breadcrumb-item{color:#dbdbdb}.novo-breadcrumb-font-style.text-color-neutral,:host .text-color-neutral.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-neutral,:host .text-color-neutral.novo-breadcrumb-item{color:#4f5361}.novo-breadcrumb-font-style.text-color-dark,:host .text-color-dark.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-dark,:host .text-color-dark.novo-breadcrumb-item{color:#3d464d}.novo-breadcrumb-font-style.text-color-orange,:host .text-color-orange.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-orange,:host .text-color-orange.novo-breadcrumb-item{color:#ff6900}.novo-breadcrumb-font-style.text-color-navigation,:host .text-color-navigation.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-navigation,:host .text-color-navigation.novo-breadcrumb-item{color:#202945}.novo-breadcrumb-font-style.text-color-skyBlue,:host .text-color-skyBlue.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-skyBlue,:host .text-color-skyBlue.novo-breadcrumb-item{color:#009bdf}.novo-breadcrumb-font-style.text-color-steel,:host .text-color-steel.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-steel,:host .text-color-steel.novo-breadcrumb-item{color:#5b6770}.novo-breadcrumb-font-style.text-color-metal,:host .text-color-metal.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-metal,:host .text-color-metal.novo-breadcrumb-item{color:#637893}.novo-breadcrumb-font-style.text-color-sand,:host .text-color-sand.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-sand,:host .text-color-sand.novo-breadcrumb-item{color:#f4f4f4}.novo-breadcrumb-font-style.text-color-silver,:host .text-color-silver.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-silver,:host .text-color-silver.novo-breadcrumb-item{color:#e2e2e2}.novo-breadcrumb-font-style.text-color-stone,:host .text-color-stone.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-stone,:host .text-color-stone.novo-breadcrumb-item{color:#bebebe}.novo-breadcrumb-font-style.text-color-ash,:host .text-color-ash.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-ash,:host .text-color-ash.novo-breadcrumb-item{color:#a0a0a0}.novo-breadcrumb-font-style.text-color-slate,:host .text-color-slate.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-slate,:host .text-color-slate.novo-breadcrumb-item{color:#707070}.novo-breadcrumb-font-style.text-color-onyx,:host .text-color-onyx.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-onyx,:host .text-color-onyx.novo-breadcrumb-item{color:#526980}.novo-breadcrumb-font-style.text-color-charcoal,:host .text-color-charcoal.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-charcoal,:host .text-color-charcoal.novo-breadcrumb-item{color:#282828}.novo-breadcrumb-font-style.text-color-moonlight,:host .text-color-moonlight.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-moonlight,:host .text-color-moonlight.novo-breadcrumb-item{color:#1a242f}.novo-breadcrumb-font-style.text-color-midnight,:host .text-color-midnight.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-midnight,:host .text-color-midnight.novo-breadcrumb-item{color:#202945}.novo-breadcrumb-font-style.text-color-darkness,:host .text-color-darkness.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-darkness,:host .text-color-darkness.novo-breadcrumb-item{color:#161f27}.novo-breadcrumb-font-style.text-color-navy,:host .text-color-navy.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-navy,:host .text-color-navy.novo-breadcrumb-item{color:#0d2d42}.novo-breadcrumb-font-style.text-color-aqua,:host .text-color-aqua.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-aqua,:host .text-color-aqua.novo-breadcrumb-item{color:#3bafda}.novo-breadcrumb-font-style.text-color-ocean,:host .text-color-ocean.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-ocean,:host .text-color-ocean.novo-breadcrumb-item{color:#4a89dc}.novo-breadcrumb-font-style.text-color-mint,:host .text-color-mint.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-mint,:host .text-color-mint.novo-breadcrumb-item{color:#37bc9b}.novo-breadcrumb-font-style.text-color-grass,:host .text-color-grass.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-grass,:host .text-color-grass.novo-breadcrumb-item{color:#8cc152}.novo-breadcrumb-font-style.text-color-sunflower,:host .text-color-sunflower.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-sunflower,:host .text-color-sunflower.novo-breadcrumb-item{color:#f6b042}.novo-breadcrumb-font-style.text-color-bittersweet,:host .text-color-bittersweet.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-bittersweet,:host .text-color-bittersweet.novo-breadcrumb-item{color:#eb6845}.novo-breadcrumb-font-style.text-color-grapefruit,:host .text-color-grapefruit.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-grapefruit,:host .text-color-grapefruit.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-carnation,:host .text-color-carnation.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-carnation,:host .text-color-carnation.novo-breadcrumb-item{color:#d770ad}.novo-breadcrumb-font-style.text-color-lavender,:host .text-color-lavender.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-lavender,:host .text-color-lavender.novo-breadcrumb-item{color:#967adc}.novo-breadcrumb-font-style.text-color-mountain,:host .text-color-mountain.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-mountain,:host .text-color-mountain.novo-breadcrumb-item{color:#9678b6}.novo-breadcrumb-font-style.text-color-info,:host .text-color-info.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-info,:host .text-color-info.novo-breadcrumb-item{color:#4a89dc}.novo-breadcrumb-font-style.text-color-positive,:host .text-color-positive.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-positive,:host .text-color-positive.novo-breadcrumb-item{color:#4a89dc}.novo-breadcrumb-font-style.text-color-success,:host .text-color-success.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-success,:host .text-color-success.novo-breadcrumb-item{color:#8cc152}.novo-breadcrumb-font-style.text-color-negative,:host .text-color-negative.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-negative,:host .text-color-negative.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-danger,:host .text-color-danger.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-danger,:host .text-color-danger.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-error,:host .text-color-error.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-error,:host .text-color-error.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-warning,:host .text-color-warning.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-warning,:host .text-color-warning.novo-breadcrumb-item{color:#f6b042}.novo-breadcrumb-font-style.text-color-empty,:host .text-color-empty.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-empty,:host .text-color-empty.novo-breadcrumb-item{color:#cccdcc}.novo-breadcrumb-font-style.text-color-disabled,:host .text-color-disabled.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-disabled,:host .text-color-disabled.novo-breadcrumb-item{color:#bebebe}.novo-breadcrumb-font-style.text-color-background,:host .text-color-background.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-background,:host .text-color-background.novo-breadcrumb-item{color:#f7f7f7}.novo-breadcrumb-font-style.text-color-backgroundDark,:host .text-color-backgroundDark.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-backgroundDark,:host .text-color-backgroundDark.novo-breadcrumb-item{color:#e2e2e2}.novo-breadcrumb-font-style.text-color-presentation,:host .text-color-presentation.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-presentation,:host .text-color-presentation.novo-breadcrumb-item{color:#5b6770}.novo-breadcrumb-font-style.text-color-bullhorn,:host .text-color-bullhorn.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-bullhorn,:host .text-color-bullhorn.novo-breadcrumb-item{color:#ff6900}.novo-breadcrumb-font-style.text-color-pulse,:host .text-color-pulse.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-pulse,:host .text-color-pulse.novo-breadcrumb-item{color:#3bafda}.novo-breadcrumb-font-style.text-color-company,:host .text-color-company.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-company,:host .text-color-company.novo-breadcrumb-item{color:#39d}.novo-breadcrumb-font-style.text-color-candidate,:host .text-color-candidate.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-candidate,:host .text-color-candidate.novo-breadcrumb-item{color:#4b7}.novo-breadcrumb-font-style.text-color-lead,:host .text-color-lead.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-lead,:host .text-color-lead.novo-breadcrumb-item{color:#a69}.novo-breadcrumb-font-style.text-color-contact,:host .text-color-contact.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-contact,:host .text-color-contact.novo-breadcrumb-item{color:#fa4}.novo-breadcrumb-font-style.text-color-clientcontact,:host .text-color-clientcontact.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-clientcontact,:host .text-color-clientcontact.novo-breadcrumb-item{color:#fa4}.novo-breadcrumb-font-style.text-color-opportunity,:host .text-color-opportunity.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-opportunity,:host .text-color-opportunity.novo-breadcrumb-item{color:#625}.novo-breadcrumb-font-style.text-color-job,:host .text-color-job.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-job,:host .text-color-job.novo-breadcrumb-item{color:#b56}.novo-breadcrumb-font-style.text-color-joborder,:host .text-color-joborder.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-joborder,:host .text-color-joborder.novo-breadcrumb-item{color:#b56}.novo-breadcrumb-font-style.text-color-submission,:host .text-color-submission.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-submission,:host .text-color-submission.novo-breadcrumb-item{color:#a9adbb}.novo-breadcrumb-font-style.text-color-sendout,:host .text-color-sendout.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-sendout,:host .text-color-sendout.novo-breadcrumb-item{color:#747884}.novo-breadcrumb-font-style.text-color-placement,:host .text-color-placement.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-placement,:host .text-color-placement.novo-breadcrumb-item{color:#0b344f}.novo-breadcrumb-font-style.text-color-note,:host .text-color-note.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-note,:host .text-color-note.novo-breadcrumb-item{color:#747884}.novo-breadcrumb-font-style.text-color-contract,:host .text-color-contract.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-contract,:host .text-color-contract.novo-breadcrumb-item{color:#454ea0}.novo-breadcrumb-font-style.text-color-jobCode,:host .text-color-jobCode.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-jobCode,:host .text-color-jobCode.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-earnCode,:host .text-color-earnCode.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-earnCode,:host .text-color-earnCode.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-invoiceStatement,:host .text-color-invoiceStatement.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-invoiceStatement,:host .text-color-invoiceStatement.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-billableCharge,:host .text-color-billableCharge.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-billableCharge,:host .text-color-billableCharge.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-payableCharge,:host .text-color-payableCharge.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-payableCharge,:host .text-color-payableCharge.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-user,:host .text-color-user.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-user,:host .text-color-user.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-corporateUser,:host .text-color-corporateUser.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-corporateUser,:host .text-color-corporateUser.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-distributionList,:host .text-color-distributionList.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-distributionList,:host .text-color-distributionList.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-credential,:host .text-color-credential.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-credential,:host .text-color-credential.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-person,:host .text-color-person.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-person,:host .text-color-person.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.margin-before,:host .margin-before.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.margin-before,:host .margin-before.novo-breadcrumb-item{margin-top:.4rem}.novo-breadcrumb-font-style.margin-after,:host .margin-after.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.margin-after,:host .margin-after.novo-breadcrumb-item{margin-bottom:.8rem}.novo-breadcrumb-font-style.text-length-small,:host .text-length-small.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-length-small,:host .text-length-small.novo-breadcrumb-item{max-width:40ch}.novo-breadcrumb-font-style.text-length-medium,:host .text-length-medium.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-length-medium,:host .text-length-medium.novo-breadcrumb-item{max-width:55ch}.novo-breadcrumb-font-style.text-length-large,:host .text-length-large.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-length-large,:host .text-length-large.novo-breadcrumb-item{max-width:70ch}.novo-breadcrumb-font-style.text-weight-hairline,:host .text-weight-hairline.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-hairline,:host .text-weight-hairline.novo-breadcrumb-item{font-weight:100}.novo-breadcrumb-font-style.text-weight-thin,:host .text-weight-thin.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-thin,:host .text-weight-thin.novo-breadcrumb-item{font-weight:200}.novo-breadcrumb-font-style.text-weight-light,:host .text-weight-light.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-light,:host .text-weight-light.novo-breadcrumb-item{font-weight:300}.novo-breadcrumb-font-style.text-weight-normal,:host .text-weight-normal.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-normal,:host .text-weight-normal.novo-breadcrumb-item{font-weight:400}.novo-breadcrumb-font-style.text-weight-medium,:host .text-weight-medium.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-medium,:host .text-weight-medium.novo-breadcrumb-item{font-weight:500}.novo-breadcrumb-font-style.text-weight-semibold,:host .text-weight-semibold.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-semibold,:host .text-weight-semibold.novo-breadcrumb-item{font-weight:600}.novo-breadcrumb-font-style.text-weight-bold,:host .text-weight-bold.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-bold,:host .text-weight-bold.novo-breadcrumb-item{font-weight:700}.novo-breadcrumb-font-style.text-weight-extrabold,:host .text-weight-extrabold.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-extrabold,:host .text-weight-extrabold.novo-breadcrumb-item{font-weight:800}.novo-breadcrumb-font-style.text-weight-heavy,:host .text-weight-heavy.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-heavy,:host .text-weight-heavy.novo-breadcrumb-item{font-weight:900}.novo-breadcrumb-font-style.text-weight-lighter,:host .text-weight-lighter.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-lighter,:host .text-weight-lighter.novo-breadcrumb-item{font-weight:lighter}.novo-breadcrumb-font-style.text-weight-bolder,:host .text-weight-bolder.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-bolder,:host .text-weight-bolder.novo-breadcrumb-item{font-weight:bolder}:host{display:flex;align-items:center;flex-flow:row nowrap}:host .novo-breadcrumb-item{cursor:auto;display:flex;align-items:center;flex-flow:row nowrap}:host .novo-breadcrumb-item ::ng-deep a:hover{text-decoration:none}:host .novo-breadcrumb-item ::ng-deep a{color:#4a89dc;cursor:pointer}:host .novo-breadcrumb-item ::ng-deep a:focus{text-decoration:none}:host .novo-breadcrumb-down-icon{vertical-align:middle;display:inline-block;cursor:pointer;width:16px;height:16px;margin-right:-5px;text-align:center;outline:none}:host .novo-breadcrumb-down-icon:hover svg g polygon{fill:var(--text-main, #3d464d)}:host .novo-breadcrumb-item-active{color:var(--text-main, #3d464d)}:host .novo-breadcrumb-item-active ::ng-deep a{color:var(--text-main, #3d464d);text-decoration:none}:host .novo-breadcrumb-item-active svg g polygon{fill:var(--text-main, #3d464d)}:host .novo-breadcrumb-item-active span{color:var(--text-main, #3d464d)}:host .novo-breadcrumb-separator{margin:0 3px}:host .novo-breadcrumb-dropdown-menu{padding:10px 0;max-width:200px}:host .novo-breadcrumb-dropdown-menu li{padding:0 15px;font-size:12px;line-height:36px;width:200px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;cursor:pointer}:host .novo-breadcrumb-dropdown-menu li a{color:#3d464d;line-height:36px;width:170px;display:inline-block}:host .novo-breadcrumb-dropdown-menu li a:focus{text-decoration:none}:host .novo-breadcrumb-dropdown-menu li:hover{background:#dbdbdb}:host .novo-breadcrumb-dropdown-menu li:hover a{text-decoration:none}:host .novo-search-container{max-width:200px}:host span.novo-breadcrumb-dropdown-origin{min-width:unset;display:inline-flex;padding:0}:host novo-search{width:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i3.NovoDropdownElement, selector: "novo-dropdown", inputs: ["parentScrollSelector", "parentScrollAction", "containerClass", "side", "scrollStrategy", "keepOpen", "height", "width", "appendToBody", "multiple", "scrollToActiveItemOnOpen"], outputs: ["toggled"] }, { kind: "component", type: i4.NovoSearchBoxElement, selector: "novo-search", inputs: ["name", "icon", "position", "placeholder", "alwaysOpen", "theme", "color", "closeOnSelect", "displayField", "displayValue", "hint", "keepOpen", "hasBackdrop", "allowPropagation", "overrideElement"], outputs: ["searchChanged", "applySearch"] }, { kind: "component", type: i5.NovoButtonElement, selector: "novo-button,button[theme]", inputs: ["color", "side", "size", "theme", "loading", "icon", "secondIcon", "disabled"] }, { kind: "component", type: i6.NovoOption, selector: "novo-option", inputs: ["selected", "keepOpen", "novoInert", "value", "disabled"], exportAs: ["novoOption"] }, { kind: "component", type: i6.NovoOptgroup, selector: "novo-optgroup", inputs: ["disabled", "label"], exportAs: ["novoOptgroup"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbItemElement, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, selector: 'novo-breadcrumb-item', template: "<ng-container *ngIf=\"showMenu; else breadcrumbContentTpl\">\n  <span [ngClass]=\"{ 'novo-breadcrumb-item-active': isOpen }\" #origin\n    class=\"novo-dropdown-no-border novo-dropdown-origin novo-breadcrumb-dropdown-origin\">\n    <ng-template [ngTemplateOutlet]=\"breadcrumbContentTpl\"></ng-template>\n    <novo-dropdown>\n      <novo-button theme=\"icon\" icon=\"collapse\" size=\"small\"></novo-button>\n      <novo-optgroup class=\"novo-breadcrumb-dropdown-menu\">\n        <div *ngIf=\"isSearch\" class=\"dropdown-search-container\">\n          <novo-search alwaysOpen=\"true\" (searchFn)=\"searchEvent($event)\" [class]=\"'search-in-dropdown'\"></novo-search>\n        </div>\n        <novo-option *ngFor=\"let item of menuListDisplay\" title=\"{{ item.name }}\">\n          <a *ngIf=\"!item.linkType || item.linkType === 'hrefLink'\" [href]=\"item.link\" rel=\"noopener\"\n            [target]=\"item.target ? item.target : '_self'\">{{ item.name }}</a>\n          <a *ngIf=\"item.linkType === 'routerLink'\" rel=\"noopener\" [target]=\"item.target\" [href]=\"item.link\"\n            (click)=\"navigateTo($event, item)\">{{ item.name }}</a>\n        </novo-option>\n      </novo-optgroup>\n    </novo-dropdown>\n  </span>\n</ng-container>\n\n<ng-template #breadcrumbContentTpl>\n  <span class=\"novo-breadcrumb-item\">\n    <ng-content></ng-content>\n  </span>\n</ng-template>\n\n<ng-template #dropDownMenuTpl>\n  <div>test</div>\n\n</ng-template>\n\n<span class=\"novo-breadcrumb-separator\">\n  <ng-template\n    [ngTemplateOutlet]=\"breadcrumbComponent.separatorIcon ? breadcrumbComponent.separatorIcon : defaultSeparator\"\n    [ngTemplateOutletContext]=\"{\n    $implicit: this\n  }\">\n  </ng-template>\n</span>\n\n<ng-template #defaultSeparator>\n  <span class=\"novo-breadcrumb-separator\">\n    /\n  </span>\n</ng-template>", styles: [".novo-breadcrumb-font-style,:host .novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a,:host .novo-breadcrumb-item{display:inline;font-weight:400;color:inherit;font-size:var(--font-size-text);transition:color .2s ease-out,opacity .2s ease-out;vertical-align:middle}.novo-breadcrumb-font-style.text-capitalize,:host .text-capitalize.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-capitalize,:host .text-capitalize.novo-breadcrumb-item{text-transform:capitalize}.novo-breadcrumb-font-style.text-uppercase,:host .text-uppercase.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-uppercase,:host .text-uppercase.novo-breadcrumb-item{text-transform:uppercase}.novo-breadcrumb-font-style.text-nowrap,:host .text-nowrap.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-nowrap,:host .text-nowrap.novo-breadcrumb-item{white-space:nowrap}.novo-breadcrumb-font-style.text-ellipsis,:host .text-ellipsis.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-ellipsis,:host .text-ellipsis.novo-breadcrumb-item{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.novo-breadcrumb-font-style.text-size-default,:host .text-size-default.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-default,:host .text-size-default.novo-breadcrumb-item{font-size:inherit}.novo-breadcrumb-font-style.text-size-body,:host .text-size-body.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-body,:host .text-size-body.novo-breadcrumb-item{font-size:1.3rem}.novo-breadcrumb-font-style.text-size-xs,:host .text-size-xs.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-xs,:host .text-size-xs.novo-breadcrumb-item{font-size:1rem}.novo-breadcrumb-font-style.text-size-sm,:host .text-size-sm.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-sm,:host .text-size-sm.novo-breadcrumb-item{font-size:1.2rem}.novo-breadcrumb-font-style.text-size-md,:host .text-size-md.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-md,:host .text-size-md.novo-breadcrumb-item{font-size:1.3rem}.novo-breadcrumb-font-style.text-size-lg,:host .text-size-lg.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-lg,:host .text-size-lg.novo-breadcrumb-item{font-size:1.6rem}.novo-breadcrumb-font-style.text-size-xl,:host .text-size-xl.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-xl,:host .text-size-xl.novo-breadcrumb-item{font-size:2rem}.novo-breadcrumb-font-style.text-size-2xl,:host .text-size-2xl.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-2xl,:host .text-size-2xl.novo-breadcrumb-item{font-size:2.6rem}.novo-breadcrumb-font-style.text-size-3xl,:host .text-size-3xl.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-3xl,:host .text-size-3xl.novo-breadcrumb-item{font-size:3.2rem}.novo-breadcrumb-font-style.text-size-smaller,:host .text-size-smaller.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-smaller,:host .text-size-smaller.novo-breadcrumb-item{font-size:.8em}.novo-breadcrumb-font-style.text-size-larger,:host .text-size-larger.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-size-larger,:host .text-size-larger.novo-breadcrumb-item{font-size:1.2em}.novo-breadcrumb-font-style.text-color-black,:host .text-color-black.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-black,:host .text-color-black.novo-breadcrumb-item{color:#000}.novo-breadcrumb-font-style.text-color-white,:host .text-color-white.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-white,:host .text-color-white.novo-breadcrumb-item{color:#fff}.novo-breadcrumb-font-style.text-color-gray,:host .text-color-gray.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-gray,:host .text-color-gray.novo-breadcrumb-item{color:#9e9e9e}.novo-breadcrumb-font-style.text-color-grey,:host .text-color-grey.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-grey,:host .text-color-grey.novo-breadcrumb-item{color:#9e9e9e}.novo-breadcrumb-font-style.text-color-offWhite,:host .text-color-offWhite.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-offWhite,:host .text-color-offWhite.novo-breadcrumb-item{color:#f7f7f7}.novo-breadcrumb-font-style.text-color-bright,:host .text-color-bright.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-bright,:host .text-color-bright.novo-breadcrumb-item{color:#f7f7f7}.novo-breadcrumb-font-style.text-color-light,:host .text-color-light.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-light,:host .text-color-light.novo-breadcrumb-item{color:#dbdbdb}.novo-breadcrumb-font-style.text-color-neutral,:host .text-color-neutral.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-neutral,:host .text-color-neutral.novo-breadcrumb-item{color:#4f5361}.novo-breadcrumb-font-style.text-color-dark,:host .text-color-dark.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-dark,:host .text-color-dark.novo-breadcrumb-item{color:#3d464d}.novo-breadcrumb-font-style.text-color-orange,:host .text-color-orange.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-orange,:host .text-color-orange.novo-breadcrumb-item{color:#ff6900}.novo-breadcrumb-font-style.text-color-navigation,:host .text-color-navigation.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-navigation,:host .text-color-navigation.novo-breadcrumb-item{color:#202945}.novo-breadcrumb-font-style.text-color-skyBlue,:host .text-color-skyBlue.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-skyBlue,:host .text-color-skyBlue.novo-breadcrumb-item{color:#009bdf}.novo-breadcrumb-font-style.text-color-steel,:host .text-color-steel.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-steel,:host .text-color-steel.novo-breadcrumb-item{color:#5b6770}.novo-breadcrumb-font-style.text-color-metal,:host .text-color-metal.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-metal,:host .text-color-metal.novo-breadcrumb-item{color:#637893}.novo-breadcrumb-font-style.text-color-sand,:host .text-color-sand.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-sand,:host .text-color-sand.novo-breadcrumb-item{color:#f4f4f4}.novo-breadcrumb-font-style.text-color-silver,:host .text-color-silver.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-silver,:host .text-color-silver.novo-breadcrumb-item{color:#e2e2e2}.novo-breadcrumb-font-style.text-color-stone,:host .text-color-stone.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-stone,:host .text-color-stone.novo-breadcrumb-item{color:#bebebe}.novo-breadcrumb-font-style.text-color-ash,:host .text-color-ash.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-ash,:host .text-color-ash.novo-breadcrumb-item{color:#a0a0a0}.novo-breadcrumb-font-style.text-color-slate,:host .text-color-slate.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-slate,:host .text-color-slate.novo-breadcrumb-item{color:#707070}.novo-breadcrumb-font-style.text-color-onyx,:host .text-color-onyx.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-onyx,:host .text-color-onyx.novo-breadcrumb-item{color:#526980}.novo-breadcrumb-font-style.text-color-charcoal,:host .text-color-charcoal.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-charcoal,:host .text-color-charcoal.novo-breadcrumb-item{color:#282828}.novo-breadcrumb-font-style.text-color-moonlight,:host .text-color-moonlight.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-moonlight,:host .text-color-moonlight.novo-breadcrumb-item{color:#1a242f}.novo-breadcrumb-font-style.text-color-midnight,:host .text-color-midnight.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-midnight,:host .text-color-midnight.novo-breadcrumb-item{color:#202945}.novo-breadcrumb-font-style.text-color-darkness,:host .text-color-darkness.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-darkness,:host .text-color-darkness.novo-breadcrumb-item{color:#161f27}.novo-breadcrumb-font-style.text-color-navy,:host .text-color-navy.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-navy,:host .text-color-navy.novo-breadcrumb-item{color:#0d2d42}.novo-breadcrumb-font-style.text-color-aqua,:host .text-color-aqua.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-aqua,:host .text-color-aqua.novo-breadcrumb-item{color:#3bafda}.novo-breadcrumb-font-style.text-color-ocean,:host .text-color-ocean.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-ocean,:host .text-color-ocean.novo-breadcrumb-item{color:#4a89dc}.novo-breadcrumb-font-style.text-color-mint,:host .text-color-mint.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-mint,:host .text-color-mint.novo-breadcrumb-item{color:#37bc9b}.novo-breadcrumb-font-style.text-color-grass,:host .text-color-grass.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-grass,:host .text-color-grass.novo-breadcrumb-item{color:#8cc152}.novo-breadcrumb-font-style.text-color-sunflower,:host .text-color-sunflower.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-sunflower,:host .text-color-sunflower.novo-breadcrumb-item{color:#f6b042}.novo-breadcrumb-font-style.text-color-bittersweet,:host .text-color-bittersweet.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-bittersweet,:host .text-color-bittersweet.novo-breadcrumb-item{color:#eb6845}.novo-breadcrumb-font-style.text-color-grapefruit,:host .text-color-grapefruit.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-grapefruit,:host .text-color-grapefruit.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-carnation,:host .text-color-carnation.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-carnation,:host .text-color-carnation.novo-breadcrumb-item{color:#d770ad}.novo-breadcrumb-font-style.text-color-lavender,:host .text-color-lavender.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-lavender,:host .text-color-lavender.novo-breadcrumb-item{color:#967adc}.novo-breadcrumb-font-style.text-color-mountain,:host .text-color-mountain.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-mountain,:host .text-color-mountain.novo-breadcrumb-item{color:#9678b6}.novo-breadcrumb-font-style.text-color-info,:host .text-color-info.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-info,:host .text-color-info.novo-breadcrumb-item{color:#4a89dc}.novo-breadcrumb-font-style.text-color-positive,:host .text-color-positive.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-positive,:host .text-color-positive.novo-breadcrumb-item{color:#4a89dc}.novo-breadcrumb-font-style.text-color-success,:host .text-color-success.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-success,:host .text-color-success.novo-breadcrumb-item{color:#8cc152}.novo-breadcrumb-font-style.text-color-negative,:host .text-color-negative.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-negative,:host .text-color-negative.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-danger,:host .text-color-danger.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-danger,:host .text-color-danger.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-error,:host .text-color-error.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-error,:host .text-color-error.novo-breadcrumb-item{color:#da4453}.novo-breadcrumb-font-style.text-color-warning,:host .text-color-warning.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-warning,:host .text-color-warning.novo-breadcrumb-item{color:#f6b042}.novo-breadcrumb-font-style.text-color-empty,:host .text-color-empty.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-empty,:host .text-color-empty.novo-breadcrumb-item{color:#cccdcc}.novo-breadcrumb-font-style.text-color-disabled,:host .text-color-disabled.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-disabled,:host .text-color-disabled.novo-breadcrumb-item{color:#bebebe}.novo-breadcrumb-font-style.text-color-background,:host .text-color-background.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-background,:host .text-color-background.novo-breadcrumb-item{color:#f7f7f7}.novo-breadcrumb-font-style.text-color-backgroundDark,:host .text-color-backgroundDark.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-backgroundDark,:host .text-color-backgroundDark.novo-breadcrumb-item{color:#e2e2e2}.novo-breadcrumb-font-style.text-color-presentation,:host .text-color-presentation.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-presentation,:host .text-color-presentation.novo-breadcrumb-item{color:#5b6770}.novo-breadcrumb-font-style.text-color-bullhorn,:host .text-color-bullhorn.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-bullhorn,:host .text-color-bullhorn.novo-breadcrumb-item{color:#ff6900}.novo-breadcrumb-font-style.text-color-pulse,:host .text-color-pulse.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-pulse,:host .text-color-pulse.novo-breadcrumb-item{color:#3bafda}.novo-breadcrumb-font-style.text-color-company,:host .text-color-company.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-company,:host .text-color-company.novo-breadcrumb-item{color:#39d}.novo-breadcrumb-font-style.text-color-candidate,:host .text-color-candidate.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-candidate,:host .text-color-candidate.novo-breadcrumb-item{color:#4b7}.novo-breadcrumb-font-style.text-color-lead,:host .text-color-lead.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-lead,:host .text-color-lead.novo-breadcrumb-item{color:#a69}.novo-breadcrumb-font-style.text-color-contact,:host .text-color-contact.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-contact,:host .text-color-contact.novo-breadcrumb-item{color:#fa4}.novo-breadcrumb-font-style.text-color-clientcontact,:host .text-color-clientcontact.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-clientcontact,:host .text-color-clientcontact.novo-breadcrumb-item{color:#fa4}.novo-breadcrumb-font-style.text-color-opportunity,:host .text-color-opportunity.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-opportunity,:host .text-color-opportunity.novo-breadcrumb-item{color:#625}.novo-breadcrumb-font-style.text-color-job,:host .text-color-job.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-job,:host .text-color-job.novo-breadcrumb-item{color:#b56}.novo-breadcrumb-font-style.text-color-joborder,:host .text-color-joborder.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-joborder,:host .text-color-joborder.novo-breadcrumb-item{color:#b56}.novo-breadcrumb-font-style.text-color-submission,:host .text-color-submission.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-submission,:host .text-color-submission.novo-breadcrumb-item{color:#a9adbb}.novo-breadcrumb-font-style.text-color-sendout,:host .text-color-sendout.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-sendout,:host .text-color-sendout.novo-breadcrumb-item{color:#747884}.novo-breadcrumb-font-style.text-color-placement,:host .text-color-placement.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-placement,:host .text-color-placement.novo-breadcrumb-item{color:#0b344f}.novo-breadcrumb-font-style.text-color-note,:host .text-color-note.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-note,:host .text-color-note.novo-breadcrumb-item{color:#747884}.novo-breadcrumb-font-style.text-color-contract,:host .text-color-contract.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-contract,:host .text-color-contract.novo-breadcrumb-item{color:#454ea0}.novo-breadcrumb-font-style.text-color-jobCode,:host .text-color-jobCode.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-jobCode,:host .text-color-jobCode.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-earnCode,:host .text-color-earnCode.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-earnCode,:host .text-color-earnCode.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-invoiceStatement,:host .text-color-invoiceStatement.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-invoiceStatement,:host .text-color-invoiceStatement.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-billableCharge,:host .text-color-billableCharge.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-billableCharge,:host .text-color-billableCharge.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-payableCharge,:host .text-color-payableCharge.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-payableCharge,:host .text-color-payableCharge.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-user,:host .text-color-user.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-user,:host .text-color-user.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-corporateUser,:host .text-color-corporateUser.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-corporateUser,:host .text-color-corporateUser.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-distributionList,:host .text-color-distributionList.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-distributionList,:host .text-color-distributionList.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-credential,:host .text-color-credential.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-credential,:host .text-color-credential.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.text-color-person,:host .text-color-person.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-color-person,:host .text-color-person.novo-breadcrumb-item{color:#696d79}.novo-breadcrumb-font-style.margin-before,:host .margin-before.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.margin-before,:host .margin-before.novo-breadcrumb-item{margin-top:.4rem}.novo-breadcrumb-font-style.margin-after,:host .margin-after.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.margin-after,:host .margin-after.novo-breadcrumb-item{margin-bottom:.8rem}.novo-breadcrumb-font-style.text-length-small,:host .text-length-small.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-length-small,:host .text-length-small.novo-breadcrumb-item{max-width:40ch}.novo-breadcrumb-font-style.text-length-medium,:host .text-length-medium.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-length-medium,:host .text-length-medium.novo-breadcrumb-item{max-width:55ch}.novo-breadcrumb-font-style.text-length-large,:host .text-length-large.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-length-large,:host .text-length-large.novo-breadcrumb-item{max-width:70ch}.novo-breadcrumb-font-style.text-weight-hairline,:host .text-weight-hairline.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-hairline,:host .text-weight-hairline.novo-breadcrumb-item{font-weight:100}.novo-breadcrumb-font-style.text-weight-thin,:host .text-weight-thin.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-thin,:host .text-weight-thin.novo-breadcrumb-item{font-weight:200}.novo-breadcrumb-font-style.text-weight-light,:host .text-weight-light.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-light,:host .text-weight-light.novo-breadcrumb-item{font-weight:300}.novo-breadcrumb-font-style.text-weight-normal,:host .text-weight-normal.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-normal,:host .text-weight-normal.novo-breadcrumb-item{font-weight:400}.novo-breadcrumb-font-style.text-weight-medium,:host .text-weight-medium.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-medium,:host .text-weight-medium.novo-breadcrumb-item{font-weight:500}.novo-breadcrumb-font-style.text-weight-semibold,:host .text-weight-semibold.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-semibold,:host .text-weight-semibold.novo-breadcrumb-item{font-weight:600}.novo-breadcrumb-font-style.text-weight-bold,:host .text-weight-bold.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-bold,:host .text-weight-bold.novo-breadcrumb-item{font-weight:700}.novo-breadcrumb-font-style.text-weight-extrabold,:host .text-weight-extrabold.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-extrabold,:host .text-weight-extrabold.novo-breadcrumb-item{font-weight:800}.novo-breadcrumb-font-style.text-weight-heavy,:host .text-weight-heavy.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-heavy,:host .text-weight-heavy.novo-breadcrumb-item{font-weight:900}.novo-breadcrumb-font-style.text-weight-lighter,:host .text-weight-lighter.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-lighter,:host .text-weight-lighter.novo-breadcrumb-item{font-weight:lighter}.novo-breadcrumb-font-style.text-weight-bolder,:host .text-weight-bolder.novo-breadcrumb-separator,:host .novo-breadcrumb-item ::ng-deep a.text-weight-bolder,:host .text-weight-bolder.novo-breadcrumb-item{font-weight:bolder}:host{display:flex;align-items:center;flex-flow:row nowrap}:host .novo-breadcrumb-item{cursor:auto;display:flex;align-items:center;flex-flow:row nowrap}:host .novo-breadcrumb-item ::ng-deep a:hover{text-decoration:none}:host .novo-breadcrumb-item ::ng-deep a{color:#4a89dc;cursor:pointer}:host .novo-breadcrumb-item ::ng-deep a:focus{text-decoration:none}:host .novo-breadcrumb-down-icon{vertical-align:middle;display:inline-block;cursor:pointer;width:16px;height:16px;margin-right:-5px;text-align:center;outline:none}:host .novo-breadcrumb-down-icon:hover svg g polygon{fill:var(--text-main, #3d464d)}:host .novo-breadcrumb-item-active{color:var(--text-main, #3d464d)}:host .novo-breadcrumb-item-active ::ng-deep a{color:var(--text-main, #3d464d);text-decoration:none}:host .novo-breadcrumb-item-active svg g polygon{fill:var(--text-main, #3d464d)}:host .novo-breadcrumb-item-active span{color:var(--text-main, #3d464d)}:host .novo-breadcrumb-separator{margin:0 3px}:host .novo-breadcrumb-dropdown-menu{padding:10px 0;max-width:200px}:host .novo-breadcrumb-dropdown-menu li{padding:0 15px;font-size:12px;line-height:36px;width:200px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;cursor:pointer}:host .novo-breadcrumb-dropdown-menu li a{color:#3d464d;line-height:36px;width:170px;display:inline-block}:host .novo-breadcrumb-dropdown-menu li a:focus{text-decoration:none}:host .novo-breadcrumb-dropdown-menu li:hover{background:#dbdbdb}:host .novo-breadcrumb-dropdown-menu li:hover a{text-decoration:none}:host .novo-search-container{max-width:200px}:host span.novo-breadcrumb-dropdown-origin{min-width:unset;display:inline-flex;padding:0}:host novo-search{width:100%}\n"] }]
        }], ctorParameters: () => [{ type: BreadcrumbService }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [NOVO_BREADCRUMB_REF]
                }] }], propDecorators: { showMenu: [{
                type: Input
            }], customMenuTemplate: [{
                type: Input
            }], menuList: [{
                type: Input
            }], isSearch: [{
                type: Input
            }], toggleEvent: [{
                type: Output
            }] } });

class BreadcrumbElement {
    constructor(breadcrumbService) {
        this.breadcrumbService = breadcrumbService;
        this.source = [];
    }
    navigateTo($event, item) {
        this.breadcrumbService.navigateTo($event, item);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbElement, deps: [{ token: BreadcrumbService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: BreadcrumbElement, selector: "novo-breadcrumb", inputs: { separatorIcon: "separatorIcon", source: "source" }, providers: [{ provide: NOVO_BREADCRUMB_REF, useExisting: BreadcrumbElement }], ngImport: i0, template: "<ng-container *ngIf=\"source && source.length\">\n  <novo-breadcrumb-item *ngFor=\"let item of source\" [showMenu]=\"item.showMenu\" [isSearch]=\"item.isSearch\"\n    [menuList]=\"item.menuList\" [customMenuTemplate]=\"item.customMenuTemplate\">\n    <a *ngIf=\"!item.noNavigation && (!item.linkType || item.linkType === 'hrefLink')\" rel=\"noopener\" [href]=\"item.link\"\n      [target]=\"item.target ? item.target : '_self'\">{{ item.title }}</a>\n    <a *ngIf=\"!item.noNavigation && item.linkType === 'routerLink'\" rel=\"noopener\" [target]=\"item.target\"\n      [href]=\"item.link\" (click)=\"navigateTo($event, item)\">{{ item.title }}</a>\n    <span *ngIf=\"item.noNavigation\">{{ item.title }}</span>\n  </novo-breadcrumb-item>\n</ng-container>\n<ng-container *ngIf=\"!(source && source.length)\">\n  <ng-content></ng-content>\n</ng-container>", styles: [":host{display:flex;align-items:center}:host ::ng-deep novo-breadcrumb-item:last-child .novo-breadcrumb-separator{display:none}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: BreadcrumbItemElement, selector: "novo-breadcrumb-item", inputs: ["showMenu", "customMenuTemplate", "menuList", "isSearch"], outputs: ["toggleEvent"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: BreadcrumbElement, decorators: [{
            type: Component,
            args: [{ selector: 'novo-breadcrumb', providers: [{ provide: NOVO_BREADCRUMB_REF, useExisting: BreadcrumbElement }], template: "<ng-container *ngIf=\"source && source.length\">\n  <novo-breadcrumb-item *ngFor=\"let item of source\" [showMenu]=\"item.showMenu\" [isSearch]=\"item.isSearch\"\n    [menuList]=\"item.menuList\" [customMenuTemplate]=\"item.customMenuTemplate\">\n    <a *ngIf=\"!item.noNavigation && (!item.linkType || item.linkType === 'hrefLink')\" rel=\"noopener\" [href]=\"item.link\"\n      [target]=\"item.target ? item.target : '_self'\">{{ item.title }}</a>\n    <a *ngIf=\"!item.noNavigation && item.linkType === 'routerLink'\" rel=\"noopener\" [target]=\"item.target\"\n      [href]=\"item.link\" (click)=\"navigateTo($event, item)\">{{ item.title }}</a>\n    <span *ngIf=\"item.noNavigation\">{{ item.title }}</span>\n  </novo-breadcrumb-item>\n</ng-container>\n<ng-container *ngIf=\"!(source && source.length)\">\n  <ng-content></ng-content>\n</ng-container>", styles: [":host{display:flex;align-items:center}:host ::ng-deep novo-breadcrumb-item:last-child .novo-breadcrumb-separator{display:none}\n"] }]
        }], ctorParameters: () => [{ type: BreadcrumbService }], propDecorators: { separatorIcon: [{
                type: Input
            }], source: [{
                type: Input
            }] } });

class NovoBreadcrumbModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoBreadcrumbModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: NovoBreadcrumbModule, declarations: [BreadcrumbElement, BreadcrumbItemElement], imports: [CommonModule, RouterModule, NovoDropdownModule, NovoSearchBoxModule, NovoButtonModule, NovoIconModule, NovoOptionModule], exports: [BreadcrumbElement, BreadcrumbItemElement] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoBreadcrumbModule, providers: [BreadcrumbService], imports: [CommonModule, RouterModule, NovoDropdownModule, NovoSearchBoxModule, NovoButtonModule, NovoIconModule, NovoOptionModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoBreadcrumbModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, RouterModule, NovoDropdownModule, NovoSearchBoxModule, NovoButtonModule, NovoIconModule, NovoOptionModule],
                    exports: [BreadcrumbElement, BreadcrumbItemElement],
                    declarations: [BreadcrumbElement, BreadcrumbItemElement],
                    providers: [BreadcrumbService],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BreadcrumbElement, BreadcrumbItemElement, BreadcrumbService, NOVO_BREADCRUMB_REF, NovoBreadcrumbModule };
//# sourceMappingURL=novo-elements-elements-breadcrumbs.mjs.map
