import * as i0 from '@angular/core';
import { Component, Input, HostBinding, NgModule } from '@angular/core';
import { BooleanInput } from 'novo-elements/utils';
import * as i1 from 'novo-elements/elements/common';
import { NovoCommonModule } from 'novo-elements/elements/common';
import * as i2 from 'novo-elements/elements/button';
import { NovoButtonModule } from 'novo-elements/elements/button';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i4 from 'novo-elements/elements/icon';
import { NovoIconModule } from 'novo-elements/elements/icon';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
class NovoHeaderSpacer {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderSpacer, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: NovoHeaderSpacer, selector: "header-spacer", ngImport: i0, template: `<ng-content></ng-content>`, isInline: true, styles: [":host{display:inline-block;height:1.8em;width:2px;margin:0 .6em;background-color:#00000040}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderSpacer, decorators: [{
            type: Component,
            args: [{ selector: 'header-spacer', template: `<ng-content></ng-content>`, styles: [":host{display:inline-block;height:1.8em;width:2px;margin:0 .6em;background-color:#00000040}\n"] }]
        }] });
class NovoUtilsComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoUtilsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: NovoUtilsComponent, selector: "utils", ngImport: i0, template: `<ng-content></ng-content>`, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoUtilsComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'utils',
                    template: `<ng-content></ng-content>`,
                }]
        }] });
class NovoUtilActionComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoUtilActionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: NovoUtilActionComponent, selector: "util-action, novo-action", inputs: { icon: "icon", size: "size", inverse: "inverse", disabled: "disabled" }, host: { classAttribute: "novo-action" }, ngImport: i0, template: `
    <novo-button theme="icon" [icon]="icon" [size]="size" [attr.inverse]="inverse" [disabled]="disabled">
      <ng-content></ng-content>
    </novo-button>
  `, isInline: true, dependencies: [{ kind: "directive", type: i1.ThemeColorDirective, selector: "[theme]", inputs: ["theme"] }, { kind: "component", type: i2.NovoButtonElement, selector: "novo-button,button[theme]", inputs: ["color", "side", "size", "theme", "loading", "icon", "secondIcon", "disabled"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoUtilActionComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'util-action, novo-action',
                    template: `
    <novo-button theme="icon" [icon]="icon" [size]="size" [attr.inverse]="inverse" [disabled]="disabled">
      <ng-content></ng-content>
    </novo-button>
  `,
                    host: {
                        class: 'novo-action',
                    },
                }]
        }], propDecorators: { icon: [{
                type: Input
            }], size: [{
                type: Input
            }], inverse: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });
class NovoHeaderComponent {
    get hb_isSizeSmall() {
        return this.size === 'small';
    }
    get hb_isSizeLarge() {
        return this.size === 'large';
    }
    get hb_isSizeDefault() {
        return !['small', 'large'].includes(this.size);
    }
    set theme(theme) {
        this._theme = theme;
        this.inverse = theme === 'white' || theme === 'off-white' || theme === 'light' ? undefined : 'inverse';
    }
    get theme() {
        return this._theme;
    }
    constructor(element) {
        this.element = element;
        this.role = 'heading';
        this.headerClass = 'novo-header';
        this.condensed = false;
        this.inverse = 'inverse';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.3.12", type: NovoHeaderComponent, selector: "novo-header,header[theme],header[accent]", inputs: { condensed: "condensed", title: "title", subTitle: "subTitle", icon: "icon", size: "size", theme: "theme" }, host: { properties: { "attr.role": "this.role", "class": "this.headerClass", "class.condensed": "this.condensed", "class.header-size-small": "this.hb_isSizeSmall", "class.header-size-large": "this.hb_isSizeLarge", "class.header-size-default": "this.hb_isSizeDefault", "attr.theme": "this.theme" } }, ngImport: i0, template: `
    <section>
      <div class="header-title">
        <ng-content select="[prefix]"></ng-content>
        <ng-container *ngIf="title">
          <novo-icon class="header-icon" *ngIf="icon">{{ icon }}</novo-icon>
          <div class="header-titles">
            <novo-title size="xl">{{ title }}</novo-title>
            <novo-title size="md" *ngIf="subTitle">{{ subTitle }}</novo-title>
          </div>
        </ng-container>
        <ng-container *ngIf="!title">
          <ng-content select="novo-icon, [novo-icon]"></ng-content>
          <div class="header-titles">
            <ng-content select="h1, h2, h3, h4, h5, h6, small, novo-title, [novo-title], [novo-subtitle]"></ng-content>
          </div>
        </ng-container>
      </div>
      <ng-content select="section"></ng-content>
      <span class="spacer"></span>
      <div class="header-actions">
        <ng-content select="novo-action,[novo-action]"></ng-content>
      </div>
      <ng-content select="utils"></ng-content>
      <ng-content select="[suffix]"></ng-content>
    </section>
    <ng-content></ng-content>
  `, isInline: true, styles: [":host{display:block;background-color:var(--background-bright, #ffffff)}:host .spacer{flex:1 1 0%}:host[size=small]>section{height:3.6rem}:host.header-size-small>section{height:3.2rem}:host.header-size-default>section{height:5rem}:host.header-size-large>section{height:6.4rem}:host>section{display:flex;flex-direction:row;align-items:center;padding:0 1.25rem;gap:.5rem;box-sizing:border-box}:host>section .header-icon{font-size:var(--font-size-2xl)}:host>section div.header-title{display:flex;align-items:center;gap:.5rem;padding-inline-end:2em;min-width:0;flex-shrink:1}:host>section div.header-title .novo-title{overflow:hidden}:host>section div.header-title ::ng-deep novo-icon{margin-right:1rem}:host>section .header-titles{display:flex;flex-direction:column;max-width:100%}:host>section .header-titles .novo-title{overflow:hidden;white-space:nowrap;text-overflow:ellipsis}:host>section .header-titles h1{font-weight:500;line-height:1.5;color:var(--text-main, #3d464d);font-size:var(--font-size-title);transition:color .2s ease-out,opacity .2s ease-out;vertical-align:middle;margin:0;padding:0 20px 0 0;display:inline-block;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}:host>section .header-titles h1.text-capitalize{text-transform:capitalize}:host>section .header-titles h1.text-uppercase{text-transform:uppercase}:host>section .header-titles h1.text-nowrap{white-space:nowrap}:host>section .header-titles h1.text-ellipsis{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}:host>section .header-titles h1.text-size-default{font-size:inherit}:host>section .header-titles h1.text-size-body{font-size:1.3rem}:host>section .header-titles h1.text-size-xs{font-size:1rem}:host>section .header-titles h1.text-size-sm{font-size:1.2rem}:host>section .header-titles h1.text-size-md{font-size:1.3rem}:host>section .header-titles h1.text-size-lg{font-size:1.6rem}:host>section .header-titles h1.text-size-xl{font-size:2rem}:host>section .header-titles h1.text-size-2xl{font-size:2.6rem}:host>section .header-titles h1.text-size-3xl{font-size:3.2rem}:host>section .header-titles h1.text-size-smaller{font-size:.8em}:host>section .header-titles h1.text-size-larger{font-size:1.2em}:host>section .header-titles h1.text-color-black{color:#000}:host>section .header-titles h1.text-color-white{color:#fff}:host>section .header-titles h1.text-color-gray{color:#9e9e9e}:host>section .header-titles h1.text-color-grey{color:#9e9e9e}:host>section .header-titles h1.text-color-offWhite{color:#f7f7f7}:host>section .header-titles h1.text-color-bright{color:#f7f7f7}:host>section .header-titles h1.text-color-light{color:#dbdbdb}:host>section .header-titles h1.text-color-neutral{color:#4f5361}:host>section .header-titles h1.text-color-dark{color:#3d464d}:host>section .header-titles h1.text-color-orange{color:#ff6900}:host>section .header-titles h1.text-color-navigation{color:#202945}:host>section .header-titles h1.text-color-skyBlue{color:#009bdf}:host>section .header-titles h1.text-color-steel{color:#5b6770}:host>section .header-titles h1.text-color-metal{color:#637893}:host>section .header-titles h1.text-color-sand{color:#f4f4f4}:host>section .header-titles h1.text-color-silver{color:#e2e2e2}:host>section .header-titles h1.text-color-stone{color:#bebebe}:host>section .header-titles h1.text-color-ash{color:#a0a0a0}:host>section .header-titles h1.text-color-slate{color:#707070}:host>section .header-titles h1.text-color-onyx{color:#526980}:host>section .header-titles h1.text-color-charcoal{color:#282828}:host>section .header-titles h1.text-color-moonlight{color:#1a242f}:host>section .header-titles h1.text-color-midnight{color:#202945}:host>section .header-titles h1.text-color-darkness{color:#161f27}:host>section .header-titles h1.text-color-navy{color:#0d2d42}:host>section .header-titles h1.text-color-aqua{color:#3bafda}:host>section .header-titles h1.text-color-ocean{color:#4a89dc}:host>section .header-titles h1.text-color-mint{color:#37bc9b}:host>section .header-titles h1.text-color-grass{color:#8cc152}:host>section .header-titles h1.text-color-sunflower{color:#f6b042}:host>section .header-titles h1.text-color-bittersweet{color:#eb6845}:host>section .header-titles h1.text-color-grapefruit{color:#da4453}:host>section .header-titles h1.text-color-carnation{color:#d770ad}:host>section .header-titles h1.text-color-lavender{color:#967adc}:host>section .header-titles h1.text-color-mountain{color:#9678b6}:host>section .header-titles h1.text-color-info{color:#4a89dc}:host>section .header-titles h1.text-color-positive{color:#4a89dc}:host>section .header-titles h1.text-color-success{color:#8cc152}:host>section .header-titles h1.text-color-negative{color:#da4453}:host>section .header-titles h1.text-color-danger{color:#da4453}:host>section .header-titles h1.text-color-error{color:#da4453}:host>section .header-titles h1.text-color-warning{color:#f6b042}:host>section .header-titles h1.text-color-empty{color:#cccdcc}:host>section .header-titles h1.text-color-disabled{color:#bebebe}:host>section .header-titles h1.text-color-background{color:#f7f7f7}:host>section .header-titles h1.text-color-backgroundDark{color:#e2e2e2}:host>section .header-titles h1.text-color-presentation{color:#5b6770}:host>section .header-titles h1.text-color-bullhorn{color:#ff6900}:host>section .header-titles h1.text-color-pulse{color:#3bafda}:host>section .header-titles h1.text-color-company{color:#39d}:host>section .header-titles h1.text-color-candidate{color:#4b7}:host>section .header-titles h1.text-color-lead{color:#a69}:host>section .header-titles h1.text-color-contact{color:#fa4}:host>section .header-titles h1.text-color-clientcontact{color:#fa4}:host>section .header-titles h1.text-color-opportunity{color:#625}:host>section .header-titles h1.text-color-job{color:#b56}:host>section .header-titles h1.text-color-joborder{color:#b56}:host>section .header-titles h1.text-color-submission{color:#a9adbb}:host>section .header-titles h1.text-color-sendout{color:#747884}:host>section .header-titles h1.text-color-placement{color:#0b344f}:host>section .header-titles h1.text-color-note{color:#747884}:host>section .header-titles h1.text-color-contract{color:#454ea0}:host>section .header-titles h1.text-color-jobCode{color:#696d79}:host>section .header-titles h1.text-color-earnCode{color:#696d79}:host>section .header-titles h1.text-color-invoiceStatement{color:#696d79}:host>section .header-titles h1.text-color-billableCharge{color:#696d79}:host>section .header-titles h1.text-color-payableCharge{color:#696d79}:host>section .header-titles h1.text-color-user{color:#696d79}:host>section .header-titles h1.text-color-corporateUser{color:#696d79}:host>section .header-titles h1.text-color-distributionList{color:#696d79}:host>section .header-titles h1.text-color-credential{color:#696d79}:host>section .header-titles h1.text-color-person{color:#696d79}:host>section .header-titles h1.margin-before{margin-top:.4rem}:host>section .header-titles h1.margin-after{margin-bottom:.8rem}:host>section .header-titles h1.text-length-small{max-width:40ch}:host>section .header-titles h1.text-length-medium{max-width:55ch}:host>section .header-titles h1.text-length-large{max-width:70ch}:host>section .header-titles h1.text-weight-hairline{font-weight:100}:host>section .header-titles h1.text-weight-thin{font-weight:200}:host>section .header-titles h1.text-weight-light{font-weight:300}:host>section .header-titles h1.text-weight-normal{font-weight:400}:host>section .header-titles h1.text-weight-medium{font-weight:500}:host>section .header-titles h1.text-weight-semibold{font-weight:600}:host>section .header-titles h1.text-weight-bold{font-weight:700}:host>section .header-titles h1.text-weight-extrabold{font-weight:800}:host>section .header-titles h1.text-weight-heavy{font-weight:900}:host>section .header-titles h1.text-weight-lighter{font-weight:lighter}:host>section .header-titles h1.text-weight-bolder{font-weight:bolder}:host>section>::ng-deep section{flex:2 2 250px;min-width:100px}:host>section ::ng-deep utils,:host>section ::ng-deep novo-utils{display:flex;align-items:center;justify-content:flex-start;gap:.5rem}:host>section ::ng-deep .novo-action{display:flex}:host.novo-accent-black .header-titles ::ng-deep .novo-icon,:host.novo-accent-black .header-title ::ng-deep .novo-icon{color:#000}:host.novo-accent-black>section:first-of-type{border-bottom:2px solid #000000}:host.novo-theme-black>section:first-of-type{background:#000;color:#fff;border-bottom:none}:host.novo-theme-black ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-black ::ng-deep .novo-action button,:host.novo-theme-black ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-white .header-titles ::ng-deep .novo-icon,:host.novo-accent-white .header-title ::ng-deep .novo-icon{color:#fff}:host.novo-accent-white>section:first-of-type{border-bottom:2px solid #ffffff}:host.novo-theme-white>section:first-of-type{background:#fff;color:#3d464d;border-bottom:none}:host.novo-theme-white ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-white ::ng-deep .novo-action button,:host.novo-theme-white ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-gray .header-titles ::ng-deep .novo-icon,:host.novo-accent-gray .header-title ::ng-deep .novo-icon{color:#9e9e9e}:host.novo-accent-gray>section:first-of-type{border-bottom:2px solid #9e9e9e}:host.novo-theme-gray>section:first-of-type{background:#9e9e9e;color:#3d464d;border-bottom:none}:host.novo-theme-gray ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-gray ::ng-deep .novo-action button,:host.novo-theme-gray ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-grey .header-titles ::ng-deep .novo-icon,:host.novo-accent-grey .header-title ::ng-deep .novo-icon{color:#9e9e9e}:host.novo-accent-grey>section:first-of-type{border-bottom:2px solid #9e9e9e}:host.novo-theme-grey>section:first-of-type{background:#9e9e9e;color:#3d464d;border-bottom:none}:host.novo-theme-grey ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-grey ::ng-deep .novo-action button,:host.novo-theme-grey ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-offWhite .header-titles ::ng-deep .novo-icon,:host.novo-accent-offWhite .header-title ::ng-deep .novo-icon{color:#f7f7f7}:host.novo-accent-offWhite>section:first-of-type{border-bottom:2px solid #f7f7f7}:host.novo-theme-offWhite>section:first-of-type{background:#f7f7f7;color:#3d464d;border-bottom:none}:host.novo-theme-offWhite ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-offWhite ::ng-deep .novo-action button,:host.novo-theme-offWhite ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-bright .header-titles ::ng-deep .novo-icon,:host.novo-accent-bright .header-title ::ng-deep .novo-icon{color:#f7f7f7}:host.novo-accent-bright>section:first-of-type{border-bottom:2px solid #f7f7f7}:host.novo-theme-bright>section:first-of-type{background:#f7f7f7;color:#3d464d;border-bottom:none}:host.novo-theme-bright ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-bright ::ng-deep .novo-action button,:host.novo-theme-bright ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-light .header-titles ::ng-deep .novo-icon,:host.novo-accent-light .header-title ::ng-deep .novo-icon{color:#dbdbdb}:host.novo-accent-light>section:first-of-type{border-bottom:2px solid #dbdbdb}:host.novo-theme-light>section:first-of-type{background:#dbdbdb;color:#3d464d;border-bottom:none}:host.novo-theme-light ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-light ::ng-deep .novo-action button,:host.novo-theme-light ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-neutral .header-titles ::ng-deep .novo-icon,:host.novo-accent-neutral .header-title ::ng-deep .novo-icon{color:#4f5361}:host.novo-accent-neutral>section:first-of-type{border-bottom:2px solid #4f5361}:host.novo-theme-neutral>section:first-of-type{background:#4f5361;color:#fff;border-bottom:none}:host.novo-theme-neutral ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-neutral ::ng-deep .novo-action button,:host.novo-theme-neutral ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-dark .header-titles ::ng-deep .novo-icon,:host.novo-accent-dark .header-title ::ng-deep .novo-icon{color:#3d464d}:host.novo-accent-dark>section:first-of-type{border-bottom:2px solid #3d464d}:host.novo-theme-dark>section:first-of-type{background:#3d464d;color:#fff;border-bottom:none}:host.novo-theme-dark ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-dark ::ng-deep .novo-action button,:host.novo-theme-dark ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-orange .header-titles ::ng-deep .novo-icon,:host.novo-accent-orange .header-title ::ng-deep .novo-icon{color:#ff6900}:host.novo-accent-orange>section:first-of-type{border-bottom:2px solid #ff6900}:host.novo-theme-orange>section:first-of-type{background:#ff6900;color:#3d464d;border-bottom:none}:host.novo-theme-orange ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-orange ::ng-deep .novo-action button,:host.novo-theme-orange ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-navigation .header-titles ::ng-deep .novo-icon,:host.novo-accent-navigation .header-title ::ng-deep .novo-icon{color:#202945}:host.novo-accent-navigation>section:first-of-type{border-bottom:2px solid #202945}:host.novo-theme-navigation>section:first-of-type{background:#202945;color:#fff;border-bottom:none}:host.novo-theme-navigation ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-navigation ::ng-deep .novo-action button,:host.novo-theme-navigation ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-skyBlue .header-titles ::ng-deep .novo-icon,:host.novo-accent-skyBlue .header-title ::ng-deep .novo-icon{color:#009bdf}:host.novo-accent-skyBlue>section:first-of-type{border-bottom:2px solid #009bdf}:host.novo-theme-skyBlue>section:first-of-type{background:#009bdf;color:#fff;border-bottom:none}:host.novo-theme-skyBlue ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-skyBlue ::ng-deep .novo-action button,:host.novo-theme-skyBlue ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-steel .header-titles ::ng-deep .novo-icon,:host.novo-accent-steel .header-title ::ng-deep .novo-icon{color:#5b6770}:host.novo-accent-steel>section:first-of-type{border-bottom:2px solid #5b6770}:host.novo-theme-steel>section:first-of-type{background:#5b6770;color:#fff;border-bottom:none}:host.novo-theme-steel ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-steel ::ng-deep .novo-action button,:host.novo-theme-steel ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-metal .header-titles ::ng-deep .novo-icon,:host.novo-accent-metal .header-title ::ng-deep .novo-icon{color:#637893}:host.novo-accent-metal>section:first-of-type{border-bottom:2px solid #637893}:host.novo-theme-metal>section:first-of-type{background:#637893;color:#fff;border-bottom:none}:host.novo-theme-metal ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-metal ::ng-deep .novo-action button,:host.novo-theme-metal ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-sand .header-titles ::ng-deep .novo-icon,:host.novo-accent-sand .header-title ::ng-deep .novo-icon{color:#f4f4f4}:host.novo-accent-sand>section:first-of-type{border-bottom:2px solid #f4f4f4}:host.novo-theme-sand>section:first-of-type{background:#f4f4f4;color:#3d464d;border-bottom:none}:host.novo-theme-sand ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-sand ::ng-deep .novo-action button,:host.novo-theme-sand ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-silver .header-titles ::ng-deep .novo-icon,:host.novo-accent-silver .header-title ::ng-deep .novo-icon{color:#e2e2e2}:host.novo-accent-silver>section:first-of-type{border-bottom:2px solid #e2e2e2}:host.novo-theme-silver>section:first-of-type{background:#e2e2e2;color:#3d464d;border-bottom:none}:host.novo-theme-silver ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-silver ::ng-deep .novo-action button,:host.novo-theme-silver ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-stone .header-titles ::ng-deep .novo-icon,:host.novo-accent-stone .header-title ::ng-deep .novo-icon{color:#bebebe}:host.novo-accent-stone>section:first-of-type{border-bottom:2px solid #bebebe}:host.novo-theme-stone>section:first-of-type{background:#bebebe;color:#3d464d;border-bottom:none}:host.novo-theme-stone ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-stone ::ng-deep .novo-action button,:host.novo-theme-stone ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-ash .header-titles ::ng-deep .novo-icon,:host.novo-accent-ash .header-title ::ng-deep .novo-icon{color:#a0a0a0}:host.novo-accent-ash>section:first-of-type{border-bottom:2px solid #a0a0a0}:host.novo-theme-ash>section:first-of-type{background:#a0a0a0;color:#3d464d;border-bottom:none}:host.novo-theme-ash ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-ash ::ng-deep .novo-action button,:host.novo-theme-ash ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-slate .header-titles ::ng-deep .novo-icon,:host.novo-accent-slate .header-title ::ng-deep .novo-icon{color:#707070}:host.novo-accent-slate>section:first-of-type{border-bottom:2px solid #707070}:host.novo-theme-slate>section:first-of-type{background:#707070;color:#fff;border-bottom:none}:host.novo-theme-slate ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-slate ::ng-deep .novo-action button,:host.novo-theme-slate ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-onyx .header-titles ::ng-deep .novo-icon,:host.novo-accent-onyx .header-title ::ng-deep .novo-icon{color:#526980}:host.novo-accent-onyx>section:first-of-type{border-bottom:2px solid #526980}:host.novo-theme-onyx>section:first-of-type{background:#526980;color:#fff;border-bottom:none}:host.novo-theme-onyx ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-onyx ::ng-deep .novo-action button,:host.novo-theme-onyx ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-charcoal .header-titles ::ng-deep .novo-icon,:host.novo-accent-charcoal .header-title ::ng-deep .novo-icon{color:#282828}:host.novo-accent-charcoal>section:first-of-type{border-bottom:2px solid #282828}:host.novo-theme-charcoal>section:first-of-type{background:#282828;color:#fff;border-bottom:none}:host.novo-theme-charcoal ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-charcoal ::ng-deep .novo-action button,:host.novo-theme-charcoal ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-moonlight .header-titles ::ng-deep .novo-icon,:host.novo-accent-moonlight .header-title ::ng-deep .novo-icon{color:#1a242f}:host.novo-accent-moonlight>section:first-of-type{border-bottom:2px solid #1a242f}:host.novo-theme-moonlight>section:first-of-type{background:#1a242f;color:#fff;border-bottom:none}:host.novo-theme-moonlight ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-moonlight ::ng-deep .novo-action button,:host.novo-theme-moonlight ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-midnight .header-titles ::ng-deep .novo-icon,:host.novo-accent-midnight .header-title ::ng-deep .novo-icon{color:#202945}:host.novo-accent-midnight>section:first-of-type{border-bottom:2px solid #202945}:host.novo-theme-midnight>section:first-of-type{background:#202945;color:#fff;border-bottom:none}:host.novo-theme-midnight ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-midnight ::ng-deep .novo-action button,:host.novo-theme-midnight ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-darkness .header-titles ::ng-deep .novo-icon,:host.novo-accent-darkness .header-title ::ng-deep .novo-icon{color:#161f27}:host.novo-accent-darkness>section:first-of-type{border-bottom:2px solid #161f27}:host.novo-theme-darkness>section:first-of-type{background:#161f27;color:#fff;border-bottom:none}:host.novo-theme-darkness ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-darkness ::ng-deep .novo-action button,:host.novo-theme-darkness ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-navy .header-titles ::ng-deep .novo-icon,:host.novo-accent-navy .header-title ::ng-deep .novo-icon{color:#0d2d42}:host.novo-accent-navy>section:first-of-type{border-bottom:2px solid #0d2d42}:host.novo-theme-navy>section:first-of-type{background:#0d2d42;color:#fff;border-bottom:none}:host.novo-theme-navy ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-navy ::ng-deep .novo-action button,:host.novo-theme-navy ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-aqua .header-titles ::ng-deep .novo-icon,:host.novo-accent-aqua .header-title ::ng-deep .novo-icon{color:#3bafda}:host.novo-accent-aqua>section:first-of-type{border-bottom:2px solid #3bafda}:host.novo-theme-aqua>section:first-of-type{background:#3bafda;color:#3d464d;border-bottom:none}:host.novo-theme-aqua ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-aqua ::ng-deep .novo-action button,:host.novo-theme-aqua ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-ocean .header-titles ::ng-deep .novo-icon,:host.novo-accent-ocean .header-title ::ng-deep .novo-icon{color:#4a89dc}:host.novo-accent-ocean>section:first-of-type{border-bottom:2px solid #4a89dc}:host.novo-theme-ocean>section:first-of-type{background:#4a89dc;color:#fff;border-bottom:none}:host.novo-theme-ocean ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-ocean ::ng-deep .novo-action button,:host.novo-theme-ocean ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-mint .header-titles ::ng-deep .novo-icon,:host.novo-accent-mint .header-title ::ng-deep .novo-icon{color:#37bc9b}:host.novo-accent-mint>section:first-of-type{border-bottom:2px solid #37bc9b}:host.novo-theme-mint>section:first-of-type{background:#37bc9b;color:#3d464d;border-bottom:none}:host.novo-theme-mint ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-mint ::ng-deep .novo-action button,:host.novo-theme-mint ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-grass .header-titles ::ng-deep .novo-icon,:host.novo-accent-grass .header-title ::ng-deep .novo-icon{color:#8cc152}:host.novo-accent-grass>section:first-of-type{border-bottom:2px solid #8cc152}:host.novo-theme-grass>section:first-of-type{background:#8cc152;color:#fff;border-bottom:none}:host.novo-theme-grass ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-grass ::ng-deep .novo-action button,:host.novo-theme-grass ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-sunflower .header-titles ::ng-deep .novo-icon,:host.novo-accent-sunflower .header-title ::ng-deep .novo-icon{color:#f6b042}:host.novo-accent-sunflower>section:first-of-type{border-bottom:2px solid #f6b042}:host.novo-theme-sunflower>section:first-of-type{background:#f6b042;color:#fff;border-bottom:none}:host.novo-theme-sunflower ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-sunflower ::ng-deep .novo-action button,:host.novo-theme-sunflower ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-bittersweet .header-titles ::ng-deep .novo-icon,:host.novo-accent-bittersweet .header-title ::ng-deep .novo-icon{color:#eb6845}:host.novo-accent-bittersweet>section:first-of-type{border-bottom:2px solid #eb6845}:host.novo-theme-bittersweet>section:first-of-type{background:#eb6845;color:#fff;border-bottom:none}:host.novo-theme-bittersweet ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-bittersweet ::ng-deep .novo-action button,:host.novo-theme-bittersweet ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-grapefruit .header-titles ::ng-deep .novo-icon,:host.novo-accent-grapefruit .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-grapefruit>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-grapefruit>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-grapefruit ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-grapefruit ::ng-deep .novo-action button,:host.novo-theme-grapefruit ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-carnation .header-titles ::ng-deep .novo-icon,:host.novo-accent-carnation .header-title ::ng-deep .novo-icon{color:#d770ad}:host.novo-accent-carnation>section:first-of-type{border-bottom:2px solid #d770ad}:host.novo-theme-carnation>section:first-of-type{background:#d770ad;color:#fff;border-bottom:none}:host.novo-theme-carnation ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-carnation ::ng-deep .novo-action button,:host.novo-theme-carnation ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-lavender .header-titles ::ng-deep .novo-icon,:host.novo-accent-lavender .header-title ::ng-deep .novo-icon{color:#967adc}:host.novo-accent-lavender>section:first-of-type{border-bottom:2px solid #967adc}:host.novo-theme-lavender>section:first-of-type{background:#967adc;color:#fff;border-bottom:none}:host.novo-theme-lavender ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-lavender ::ng-deep .novo-action button,:host.novo-theme-lavender ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-mountain .header-titles ::ng-deep .novo-icon,:host.novo-accent-mountain .header-title ::ng-deep .novo-icon{color:#9678b6}:host.novo-accent-mountain>section:first-of-type{border-bottom:2px solid #9678b6}:host.novo-theme-mountain>section:first-of-type{background:#9678b6;color:#fff;border-bottom:none}:host.novo-theme-mountain ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-mountain ::ng-deep .novo-action button,:host.novo-theme-mountain ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-info .header-titles ::ng-deep .novo-icon,:host.novo-accent-info .header-title ::ng-deep .novo-icon{color:#4a89dc}:host.novo-accent-info>section:first-of-type{border-bottom:2px solid #4a89dc}:host.novo-theme-info>section:first-of-type{background:#4a89dc;color:#fff;border-bottom:none}:host.novo-theme-info ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-info ::ng-deep .novo-action button,:host.novo-theme-info ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-positive .header-titles ::ng-deep .novo-icon,:host.novo-accent-positive .header-title ::ng-deep .novo-icon{color:#4a89dc}:host.novo-accent-positive>section:first-of-type{border-bottom:2px solid #4a89dc}:host.novo-theme-positive>section:first-of-type{background:#4a89dc;color:#fff;border-bottom:none}:host.novo-theme-positive ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-positive ::ng-deep .novo-action button,:host.novo-theme-positive ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-success .header-titles ::ng-deep .novo-icon,:host.novo-accent-success .header-title ::ng-deep .novo-icon{color:#8cc152}:host.novo-accent-success>section:first-of-type{border-bottom:2px solid #8cc152}:host.novo-theme-success>section:first-of-type{background:#8cc152;color:#fff;border-bottom:none}:host.novo-theme-success ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-success ::ng-deep .novo-action button,:host.novo-theme-success ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-negative .header-titles ::ng-deep .novo-icon,:host.novo-accent-negative .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-negative>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-negative>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-negative ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-negative ::ng-deep .novo-action button,:host.novo-theme-negative ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-danger .header-titles ::ng-deep .novo-icon,:host.novo-accent-danger .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-danger>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-danger>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-danger ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-danger ::ng-deep .novo-action button,:host.novo-theme-danger ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-error .header-titles ::ng-deep .novo-icon,:host.novo-accent-error .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-error>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-error>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-error ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-error ::ng-deep .novo-action button,:host.novo-theme-error ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-warning .header-titles ::ng-deep .novo-icon,:host.novo-accent-warning .header-title ::ng-deep .novo-icon{color:#f6b042}:host.novo-accent-warning>section:first-of-type{border-bottom:2px solid #f6b042}:host.novo-theme-warning>section:first-of-type{background:#f6b042;color:#fff;border-bottom:none}:host.novo-theme-warning ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-warning ::ng-deep .novo-action button,:host.novo-theme-warning ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-empty .header-titles ::ng-deep .novo-icon,:host.novo-accent-empty .header-title ::ng-deep .novo-icon{color:#cccdcc}:host.novo-accent-empty>section:first-of-type{border-bottom:2px solid #cccdcc}:host.novo-theme-empty>section:first-of-type{background:#cccdcc;color:#3d464d;border-bottom:none}:host.novo-theme-empty ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-empty ::ng-deep .novo-action button,:host.novo-theme-empty ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-disabled .header-titles ::ng-deep .novo-icon,:host.novo-accent-disabled .header-title ::ng-deep .novo-icon{color:#bebebe}:host.novo-accent-disabled>section:first-of-type{border-bottom:2px solid #bebebe}:host.novo-theme-disabled>section:first-of-type{background:#bebebe;color:#3d464d;border-bottom:none}:host.novo-theme-disabled ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-disabled ::ng-deep .novo-action button,:host.novo-theme-disabled ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-background .header-titles ::ng-deep .novo-icon,:host.novo-accent-background .header-title ::ng-deep .novo-icon{color:#f7f7f7}:host.novo-accent-background>section:first-of-type{border-bottom:2px solid #f7f7f7}:host.novo-theme-background>section:first-of-type{background:#f7f7f7;color:#3d464d;border-bottom:none}:host.novo-theme-background ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-background ::ng-deep .novo-action button,:host.novo-theme-background ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-backgroundDark .header-titles ::ng-deep .novo-icon,:host.novo-accent-backgroundDark .header-title ::ng-deep .novo-icon{color:#e2e2e2}:host.novo-accent-backgroundDark>section:first-of-type{border-bottom:2px solid #e2e2e2}:host.novo-theme-backgroundDark>section:first-of-type{background:#e2e2e2;color:#3d464d;border-bottom:none}:host.novo-theme-backgroundDark ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-backgroundDark ::ng-deep .novo-action button,:host.novo-theme-backgroundDark ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-presentation .header-titles ::ng-deep .novo-icon,:host.novo-accent-presentation .header-title ::ng-deep .novo-icon{color:#5b6770}:host.novo-accent-presentation>section:first-of-type{border-bottom:2px solid #5b6770}:host.novo-theme-presentation>section:first-of-type{background:#5b6770;color:#fff;border-bottom:none}:host.novo-theme-presentation ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-presentation ::ng-deep .novo-action button,:host.novo-theme-presentation ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-bullhorn .header-titles ::ng-deep .novo-icon,:host.novo-accent-bullhorn .header-title ::ng-deep .novo-icon{color:#ff6900}:host.novo-accent-bullhorn>section:first-of-type{border-bottom:2px solid #ff6900}:host.novo-theme-bullhorn>section:first-of-type{background:#ff6900;color:#3d464d;border-bottom:none}:host.novo-theme-bullhorn ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-bullhorn ::ng-deep .novo-action button,:host.novo-theme-bullhorn ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-pulse .header-titles ::ng-deep .novo-icon,:host.novo-accent-pulse .header-title ::ng-deep .novo-icon{color:#3bafda}:host.novo-accent-pulse>section:first-of-type{border-bottom:2px solid #3bafda}:host.novo-theme-pulse>section:first-of-type{background:#3bafda;color:#3d464d;border-bottom:none}:host.novo-theme-pulse ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-pulse ::ng-deep .novo-action button,:host.novo-theme-pulse ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-company .header-titles ::ng-deep .novo-icon,:host.novo-accent-company .header-title ::ng-deep .novo-icon{color:#39d}:host.novo-accent-company>section:first-of-type{border-bottom:2px solid #3399dd}:host.novo-theme-company>section:first-of-type{background:#39d;color:#fff;border-bottom:none}:host.novo-theme-company ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-company ::ng-deep .novo-action button,:host.novo-theme-company ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-candidate .header-titles ::ng-deep .novo-icon,:host.novo-accent-candidate .header-title ::ng-deep .novo-icon{color:#4b7}:host.novo-accent-candidate>section:first-of-type{border-bottom:2px solid #44bb77}:host.novo-theme-candidate>section:first-of-type{background:#4b7;color:#fff;border-bottom:none}:host.novo-theme-candidate ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-candidate ::ng-deep .novo-action button,:host.novo-theme-candidate ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-lead .header-titles ::ng-deep .novo-icon,:host.novo-accent-lead .header-title ::ng-deep .novo-icon{color:#a69}:host.novo-accent-lead>section:first-of-type{border-bottom:2px solid #aa6699}:host.novo-theme-lead>section:first-of-type{background:#a69;color:#fff;border-bottom:none}:host.novo-theme-lead ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-lead ::ng-deep .novo-action button,:host.novo-theme-lead ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-contact .header-titles ::ng-deep .novo-icon,:host.novo-accent-contact .header-title ::ng-deep .novo-icon{color:#fa4}:host.novo-accent-contact>section:first-of-type{border-bottom:2px solid #ffaa44}:host.novo-theme-contact>section:first-of-type{background:#fa4;color:#fff;border-bottom:none}:host.novo-theme-contact ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-contact ::ng-deep .novo-action button,:host.novo-theme-contact ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-clientcontact .header-titles ::ng-deep .novo-icon,:host.novo-accent-clientcontact .header-title ::ng-deep .novo-icon{color:#fa4}:host.novo-accent-clientcontact>section:first-of-type{border-bottom:2px solid #ffaa44}:host.novo-theme-clientcontact>section:first-of-type{background:#fa4;color:#fff;border-bottom:none}:host.novo-theme-clientcontact ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-clientcontact ::ng-deep .novo-action button,:host.novo-theme-clientcontact ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-opportunity .header-titles ::ng-deep .novo-icon,:host.novo-accent-opportunity .header-title ::ng-deep .novo-icon{color:#625}:host.novo-accent-opportunity>section:first-of-type{border-bottom:2px solid #662255}:host.novo-theme-opportunity>section:first-of-type{background:#625;color:#fff;border-bottom:none}:host.novo-theme-opportunity ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-opportunity ::ng-deep .novo-action button,:host.novo-theme-opportunity ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-job .header-titles ::ng-deep .novo-icon,:host.novo-accent-job .header-title ::ng-deep .novo-icon{color:#b56}:host.novo-accent-job>section:first-of-type{border-bottom:2px solid #bb5566}:host.novo-theme-job>section:first-of-type{background:#b56;color:#fff;border-bottom:none}:host.novo-theme-job ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-job ::ng-deep .novo-action button,:host.novo-theme-job ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-joborder .header-titles ::ng-deep .novo-icon,:host.novo-accent-joborder .header-title ::ng-deep .novo-icon{color:#b56}:host.novo-accent-joborder>section:first-of-type{border-bottom:2px solid #bb5566}:host.novo-theme-joborder>section:first-of-type{background:#b56;color:#fff;border-bottom:none}:host.novo-theme-joborder ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-joborder ::ng-deep .novo-action button,:host.novo-theme-joborder ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-submission .header-titles ::ng-deep .novo-icon,:host.novo-accent-submission .header-title ::ng-deep .novo-icon{color:#a9adbb}:host.novo-accent-submission>section:first-of-type{border-bottom:2px solid #a9adbb}:host.novo-theme-submission>section:first-of-type{background:#a9adbb;color:#3d464d;border-bottom:none}:host.novo-theme-submission ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-submission ::ng-deep .novo-action button,:host.novo-theme-submission ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-sendout .header-titles ::ng-deep .novo-icon,:host.novo-accent-sendout .header-title ::ng-deep .novo-icon{color:#747884}:host.novo-accent-sendout>section:first-of-type{border-bottom:2px solid #747884}:host.novo-theme-sendout>section:first-of-type{background:#747884;color:#fff;border-bottom:none}:host.novo-theme-sendout ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-sendout ::ng-deep .novo-action button,:host.novo-theme-sendout ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-placement .header-titles ::ng-deep .novo-icon,:host.novo-accent-placement .header-title ::ng-deep .novo-icon{color:#0b344f}:host.novo-accent-placement>section:first-of-type{border-bottom:2px solid #0b344f}:host.novo-theme-placement>section:first-of-type{background:#0b344f;color:#fff;border-bottom:none}:host.novo-theme-placement ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-placement ::ng-deep .novo-action button,:host.novo-theme-placement ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-note .header-titles ::ng-deep .novo-icon,:host.novo-accent-note .header-title ::ng-deep .novo-icon{color:#747884}:host.novo-accent-note>section:first-of-type{border-bottom:2px solid #747884}:host.novo-theme-note>section:first-of-type{background:#747884;color:#fff;border-bottom:none}:host.novo-theme-note ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-note ::ng-deep .novo-action button,:host.novo-theme-note ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-contract .header-titles ::ng-deep .novo-icon,:host.novo-accent-contract .header-title ::ng-deep .novo-icon{color:#454ea0}:host.novo-accent-contract>section:first-of-type{border-bottom:2px solid #454ea0}:host.novo-theme-contract>section:first-of-type{background:#454ea0;color:#fff;border-bottom:none}:host.novo-theme-contract ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-contract ::ng-deep .novo-action button,:host.novo-theme-contract ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-jobCode .header-titles ::ng-deep .novo-icon,:host.novo-accent-jobCode .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-jobCode>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-jobCode>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-jobCode ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-jobCode ::ng-deep .novo-action button,:host.novo-theme-jobCode ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-earnCode .header-titles ::ng-deep .novo-icon,:host.novo-accent-earnCode .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-earnCode>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-earnCode>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-earnCode ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-earnCode ::ng-deep .novo-action button,:host.novo-theme-earnCode ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-invoiceStatement .header-titles ::ng-deep .novo-icon,:host.novo-accent-invoiceStatement .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-invoiceStatement>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-invoiceStatement>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-invoiceStatement ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-invoiceStatement ::ng-deep .novo-action button,:host.novo-theme-invoiceStatement ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-billableCharge .header-titles ::ng-deep .novo-icon,:host.novo-accent-billableCharge .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-billableCharge>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-billableCharge>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-billableCharge ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-billableCharge ::ng-deep .novo-action button,:host.novo-theme-billableCharge ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-payableCharge .header-titles ::ng-deep .novo-icon,:host.novo-accent-payableCharge .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-payableCharge>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-payableCharge>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-payableCharge ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-payableCharge ::ng-deep .novo-action button,:host.novo-theme-payableCharge ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-user .header-titles ::ng-deep .novo-icon,:host.novo-accent-user .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-user>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-user>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-user ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-user ::ng-deep .novo-action button,:host.novo-theme-user ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-corporateUser .header-titles ::ng-deep .novo-icon,:host.novo-accent-corporateUser .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-corporateUser>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-corporateUser>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-corporateUser ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-corporateUser ::ng-deep .novo-action button,:host.novo-theme-corporateUser ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-distributionList .header-titles ::ng-deep .novo-icon,:host.novo-accent-distributionList .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-distributionList>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-distributionList>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-distributionList ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-distributionList ::ng-deep .novo-action button,:host.novo-theme-distributionList ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-credential .header-titles ::ng-deep .novo-icon,:host.novo-accent-credential .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-credential>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-credential>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-credential ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-credential ::ng-deep .novo-action button,:host.novo-theme-credential ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-person .header-titles ::ng-deep .novo-icon,:host.novo-accent-person .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-person>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-person>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-person ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-person ::ng-deep .novo-action button,:host.novo-theme-person ::ng-deep .novo-action .novo-button{color:inherit}:host>main{padding:4px 16px 4px 32px}:host>::ng-deep novo-nav{padding-left:16px}:host>::ng-deep novo-nav.block{padding-left:0}:host.condensed .header-title,:host.condensed .header-titles{line-height:1.375}:host.condensed>section{height:3.6rem}:host.condensed ::ng-deep .novo-icon{margin-right:.5rem!important;font-size:1.8rem}:host .header-actions{display:flex;flex-flow:row nowrap}\n"], dependencies: [{ kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i1.NovoTitle, selector: "novo-title,[novo-title]" }, { kind: "component", type: i4.NovoIconComponent, selector: "novo-icon", inputs: ["raised", "theme", "shape", "color", "size", "smaller", "larger", "alt", "name"] }] }); }
}
__decorate([
    BooleanInput(),
    __metadata("design:type", Boolean)
], NovoHeaderComponent.prototype, "condensed", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'novo-header,header[theme],header[accent]', template: `
    <section>
      <div class="header-title">
        <ng-content select="[prefix]"></ng-content>
        <ng-container *ngIf="title">
          <novo-icon class="header-icon" *ngIf="icon">{{ icon }}</novo-icon>
          <div class="header-titles">
            <novo-title size="xl">{{ title }}</novo-title>
            <novo-title size="md" *ngIf="subTitle">{{ subTitle }}</novo-title>
          </div>
        </ng-container>
        <ng-container *ngIf="!title">
          <ng-content select="novo-icon, [novo-icon]"></ng-content>
          <div class="header-titles">
            <ng-content select="h1, h2, h3, h4, h5, h6, small, novo-title, [novo-title], [novo-subtitle]"></ng-content>
          </div>
        </ng-container>
      </div>
      <ng-content select="section"></ng-content>
      <span class="spacer"></span>
      <div class="header-actions">
        <ng-content select="novo-action,[novo-action]"></ng-content>
      </div>
      <ng-content select="utils"></ng-content>
      <ng-content select="[suffix]"></ng-content>
    </section>
    <ng-content></ng-content>
  `, styles: [":host{display:block;background-color:var(--background-bright, #ffffff)}:host .spacer{flex:1 1 0%}:host[size=small]>section{height:3.6rem}:host.header-size-small>section{height:3.2rem}:host.header-size-default>section{height:5rem}:host.header-size-large>section{height:6.4rem}:host>section{display:flex;flex-direction:row;align-items:center;padding:0 1.25rem;gap:.5rem;box-sizing:border-box}:host>section .header-icon{font-size:var(--font-size-2xl)}:host>section div.header-title{display:flex;align-items:center;gap:.5rem;padding-inline-end:2em;min-width:0;flex-shrink:1}:host>section div.header-title .novo-title{overflow:hidden}:host>section div.header-title ::ng-deep novo-icon{margin-right:1rem}:host>section .header-titles{display:flex;flex-direction:column;max-width:100%}:host>section .header-titles .novo-title{overflow:hidden;white-space:nowrap;text-overflow:ellipsis}:host>section .header-titles h1{font-weight:500;line-height:1.5;color:var(--text-main, #3d464d);font-size:var(--font-size-title);transition:color .2s ease-out,opacity .2s ease-out;vertical-align:middle;margin:0;padding:0 20px 0 0;display:inline-block;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}:host>section .header-titles h1.text-capitalize{text-transform:capitalize}:host>section .header-titles h1.text-uppercase{text-transform:uppercase}:host>section .header-titles h1.text-nowrap{white-space:nowrap}:host>section .header-titles h1.text-ellipsis{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}:host>section .header-titles h1.text-size-default{font-size:inherit}:host>section .header-titles h1.text-size-body{font-size:1.3rem}:host>section .header-titles h1.text-size-xs{font-size:1rem}:host>section .header-titles h1.text-size-sm{font-size:1.2rem}:host>section .header-titles h1.text-size-md{font-size:1.3rem}:host>section .header-titles h1.text-size-lg{font-size:1.6rem}:host>section .header-titles h1.text-size-xl{font-size:2rem}:host>section .header-titles h1.text-size-2xl{font-size:2.6rem}:host>section .header-titles h1.text-size-3xl{font-size:3.2rem}:host>section .header-titles h1.text-size-smaller{font-size:.8em}:host>section .header-titles h1.text-size-larger{font-size:1.2em}:host>section .header-titles h1.text-color-black{color:#000}:host>section .header-titles h1.text-color-white{color:#fff}:host>section .header-titles h1.text-color-gray{color:#9e9e9e}:host>section .header-titles h1.text-color-grey{color:#9e9e9e}:host>section .header-titles h1.text-color-offWhite{color:#f7f7f7}:host>section .header-titles h1.text-color-bright{color:#f7f7f7}:host>section .header-titles h1.text-color-light{color:#dbdbdb}:host>section .header-titles h1.text-color-neutral{color:#4f5361}:host>section .header-titles h1.text-color-dark{color:#3d464d}:host>section .header-titles h1.text-color-orange{color:#ff6900}:host>section .header-titles h1.text-color-navigation{color:#202945}:host>section .header-titles h1.text-color-skyBlue{color:#009bdf}:host>section .header-titles h1.text-color-steel{color:#5b6770}:host>section .header-titles h1.text-color-metal{color:#637893}:host>section .header-titles h1.text-color-sand{color:#f4f4f4}:host>section .header-titles h1.text-color-silver{color:#e2e2e2}:host>section .header-titles h1.text-color-stone{color:#bebebe}:host>section .header-titles h1.text-color-ash{color:#a0a0a0}:host>section .header-titles h1.text-color-slate{color:#707070}:host>section .header-titles h1.text-color-onyx{color:#526980}:host>section .header-titles h1.text-color-charcoal{color:#282828}:host>section .header-titles h1.text-color-moonlight{color:#1a242f}:host>section .header-titles h1.text-color-midnight{color:#202945}:host>section .header-titles h1.text-color-darkness{color:#161f27}:host>section .header-titles h1.text-color-navy{color:#0d2d42}:host>section .header-titles h1.text-color-aqua{color:#3bafda}:host>section .header-titles h1.text-color-ocean{color:#4a89dc}:host>section .header-titles h1.text-color-mint{color:#37bc9b}:host>section .header-titles h1.text-color-grass{color:#8cc152}:host>section .header-titles h1.text-color-sunflower{color:#f6b042}:host>section .header-titles h1.text-color-bittersweet{color:#eb6845}:host>section .header-titles h1.text-color-grapefruit{color:#da4453}:host>section .header-titles h1.text-color-carnation{color:#d770ad}:host>section .header-titles h1.text-color-lavender{color:#967adc}:host>section .header-titles h1.text-color-mountain{color:#9678b6}:host>section .header-titles h1.text-color-info{color:#4a89dc}:host>section .header-titles h1.text-color-positive{color:#4a89dc}:host>section .header-titles h1.text-color-success{color:#8cc152}:host>section .header-titles h1.text-color-negative{color:#da4453}:host>section .header-titles h1.text-color-danger{color:#da4453}:host>section .header-titles h1.text-color-error{color:#da4453}:host>section .header-titles h1.text-color-warning{color:#f6b042}:host>section .header-titles h1.text-color-empty{color:#cccdcc}:host>section .header-titles h1.text-color-disabled{color:#bebebe}:host>section .header-titles h1.text-color-background{color:#f7f7f7}:host>section .header-titles h1.text-color-backgroundDark{color:#e2e2e2}:host>section .header-titles h1.text-color-presentation{color:#5b6770}:host>section .header-titles h1.text-color-bullhorn{color:#ff6900}:host>section .header-titles h1.text-color-pulse{color:#3bafda}:host>section .header-titles h1.text-color-company{color:#39d}:host>section .header-titles h1.text-color-candidate{color:#4b7}:host>section .header-titles h1.text-color-lead{color:#a69}:host>section .header-titles h1.text-color-contact{color:#fa4}:host>section .header-titles h1.text-color-clientcontact{color:#fa4}:host>section .header-titles h1.text-color-opportunity{color:#625}:host>section .header-titles h1.text-color-job{color:#b56}:host>section .header-titles h1.text-color-joborder{color:#b56}:host>section .header-titles h1.text-color-submission{color:#a9adbb}:host>section .header-titles h1.text-color-sendout{color:#747884}:host>section .header-titles h1.text-color-placement{color:#0b344f}:host>section .header-titles h1.text-color-note{color:#747884}:host>section .header-titles h1.text-color-contract{color:#454ea0}:host>section .header-titles h1.text-color-jobCode{color:#696d79}:host>section .header-titles h1.text-color-earnCode{color:#696d79}:host>section .header-titles h1.text-color-invoiceStatement{color:#696d79}:host>section .header-titles h1.text-color-billableCharge{color:#696d79}:host>section .header-titles h1.text-color-payableCharge{color:#696d79}:host>section .header-titles h1.text-color-user{color:#696d79}:host>section .header-titles h1.text-color-corporateUser{color:#696d79}:host>section .header-titles h1.text-color-distributionList{color:#696d79}:host>section .header-titles h1.text-color-credential{color:#696d79}:host>section .header-titles h1.text-color-person{color:#696d79}:host>section .header-titles h1.margin-before{margin-top:.4rem}:host>section .header-titles h1.margin-after{margin-bottom:.8rem}:host>section .header-titles h1.text-length-small{max-width:40ch}:host>section .header-titles h1.text-length-medium{max-width:55ch}:host>section .header-titles h1.text-length-large{max-width:70ch}:host>section .header-titles h1.text-weight-hairline{font-weight:100}:host>section .header-titles h1.text-weight-thin{font-weight:200}:host>section .header-titles h1.text-weight-light{font-weight:300}:host>section .header-titles h1.text-weight-normal{font-weight:400}:host>section .header-titles h1.text-weight-medium{font-weight:500}:host>section .header-titles h1.text-weight-semibold{font-weight:600}:host>section .header-titles h1.text-weight-bold{font-weight:700}:host>section .header-titles h1.text-weight-extrabold{font-weight:800}:host>section .header-titles h1.text-weight-heavy{font-weight:900}:host>section .header-titles h1.text-weight-lighter{font-weight:lighter}:host>section .header-titles h1.text-weight-bolder{font-weight:bolder}:host>section>::ng-deep section{flex:2 2 250px;min-width:100px}:host>section ::ng-deep utils,:host>section ::ng-deep novo-utils{display:flex;align-items:center;justify-content:flex-start;gap:.5rem}:host>section ::ng-deep .novo-action{display:flex}:host.novo-accent-black .header-titles ::ng-deep .novo-icon,:host.novo-accent-black .header-title ::ng-deep .novo-icon{color:#000}:host.novo-accent-black>section:first-of-type{border-bottom:2px solid #000000}:host.novo-theme-black>section:first-of-type{background:#000;color:#fff;border-bottom:none}:host.novo-theme-black ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-black ::ng-deep .novo-action button,:host.novo-theme-black ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-white .header-titles ::ng-deep .novo-icon,:host.novo-accent-white .header-title ::ng-deep .novo-icon{color:#fff}:host.novo-accent-white>section:first-of-type{border-bottom:2px solid #ffffff}:host.novo-theme-white>section:first-of-type{background:#fff;color:#3d464d;border-bottom:none}:host.novo-theme-white ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-white ::ng-deep .novo-action button,:host.novo-theme-white ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-gray .header-titles ::ng-deep .novo-icon,:host.novo-accent-gray .header-title ::ng-deep .novo-icon{color:#9e9e9e}:host.novo-accent-gray>section:first-of-type{border-bottom:2px solid #9e9e9e}:host.novo-theme-gray>section:first-of-type{background:#9e9e9e;color:#3d464d;border-bottom:none}:host.novo-theme-gray ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-gray ::ng-deep .novo-action button,:host.novo-theme-gray ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-grey .header-titles ::ng-deep .novo-icon,:host.novo-accent-grey .header-title ::ng-deep .novo-icon{color:#9e9e9e}:host.novo-accent-grey>section:first-of-type{border-bottom:2px solid #9e9e9e}:host.novo-theme-grey>section:first-of-type{background:#9e9e9e;color:#3d464d;border-bottom:none}:host.novo-theme-grey ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-grey ::ng-deep .novo-action button,:host.novo-theme-grey ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-offWhite .header-titles ::ng-deep .novo-icon,:host.novo-accent-offWhite .header-title ::ng-deep .novo-icon{color:#f7f7f7}:host.novo-accent-offWhite>section:first-of-type{border-bottom:2px solid #f7f7f7}:host.novo-theme-offWhite>section:first-of-type{background:#f7f7f7;color:#3d464d;border-bottom:none}:host.novo-theme-offWhite ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-offWhite ::ng-deep .novo-action button,:host.novo-theme-offWhite ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-bright .header-titles ::ng-deep .novo-icon,:host.novo-accent-bright .header-title ::ng-deep .novo-icon{color:#f7f7f7}:host.novo-accent-bright>section:first-of-type{border-bottom:2px solid #f7f7f7}:host.novo-theme-bright>section:first-of-type{background:#f7f7f7;color:#3d464d;border-bottom:none}:host.novo-theme-bright ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-bright ::ng-deep .novo-action button,:host.novo-theme-bright ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-light .header-titles ::ng-deep .novo-icon,:host.novo-accent-light .header-title ::ng-deep .novo-icon{color:#dbdbdb}:host.novo-accent-light>section:first-of-type{border-bottom:2px solid #dbdbdb}:host.novo-theme-light>section:first-of-type{background:#dbdbdb;color:#3d464d;border-bottom:none}:host.novo-theme-light ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-light ::ng-deep .novo-action button,:host.novo-theme-light ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-neutral .header-titles ::ng-deep .novo-icon,:host.novo-accent-neutral .header-title ::ng-deep .novo-icon{color:#4f5361}:host.novo-accent-neutral>section:first-of-type{border-bottom:2px solid #4f5361}:host.novo-theme-neutral>section:first-of-type{background:#4f5361;color:#fff;border-bottom:none}:host.novo-theme-neutral ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-neutral ::ng-deep .novo-action button,:host.novo-theme-neutral ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-dark .header-titles ::ng-deep .novo-icon,:host.novo-accent-dark .header-title ::ng-deep .novo-icon{color:#3d464d}:host.novo-accent-dark>section:first-of-type{border-bottom:2px solid #3d464d}:host.novo-theme-dark>section:first-of-type{background:#3d464d;color:#fff;border-bottom:none}:host.novo-theme-dark ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-dark ::ng-deep .novo-action button,:host.novo-theme-dark ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-orange .header-titles ::ng-deep .novo-icon,:host.novo-accent-orange .header-title ::ng-deep .novo-icon{color:#ff6900}:host.novo-accent-orange>section:first-of-type{border-bottom:2px solid #ff6900}:host.novo-theme-orange>section:first-of-type{background:#ff6900;color:#3d464d;border-bottom:none}:host.novo-theme-orange ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-orange ::ng-deep .novo-action button,:host.novo-theme-orange ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-navigation .header-titles ::ng-deep .novo-icon,:host.novo-accent-navigation .header-title ::ng-deep .novo-icon{color:#202945}:host.novo-accent-navigation>section:first-of-type{border-bottom:2px solid #202945}:host.novo-theme-navigation>section:first-of-type{background:#202945;color:#fff;border-bottom:none}:host.novo-theme-navigation ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-navigation ::ng-deep .novo-action button,:host.novo-theme-navigation ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-skyBlue .header-titles ::ng-deep .novo-icon,:host.novo-accent-skyBlue .header-title ::ng-deep .novo-icon{color:#009bdf}:host.novo-accent-skyBlue>section:first-of-type{border-bottom:2px solid #009bdf}:host.novo-theme-skyBlue>section:first-of-type{background:#009bdf;color:#fff;border-bottom:none}:host.novo-theme-skyBlue ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-skyBlue ::ng-deep .novo-action button,:host.novo-theme-skyBlue ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-steel .header-titles ::ng-deep .novo-icon,:host.novo-accent-steel .header-title ::ng-deep .novo-icon{color:#5b6770}:host.novo-accent-steel>section:first-of-type{border-bottom:2px solid #5b6770}:host.novo-theme-steel>section:first-of-type{background:#5b6770;color:#fff;border-bottom:none}:host.novo-theme-steel ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-steel ::ng-deep .novo-action button,:host.novo-theme-steel ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-metal .header-titles ::ng-deep .novo-icon,:host.novo-accent-metal .header-title ::ng-deep .novo-icon{color:#637893}:host.novo-accent-metal>section:first-of-type{border-bottom:2px solid #637893}:host.novo-theme-metal>section:first-of-type{background:#637893;color:#fff;border-bottom:none}:host.novo-theme-metal ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-metal ::ng-deep .novo-action button,:host.novo-theme-metal ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-sand .header-titles ::ng-deep .novo-icon,:host.novo-accent-sand .header-title ::ng-deep .novo-icon{color:#f4f4f4}:host.novo-accent-sand>section:first-of-type{border-bottom:2px solid #f4f4f4}:host.novo-theme-sand>section:first-of-type{background:#f4f4f4;color:#3d464d;border-bottom:none}:host.novo-theme-sand ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-sand ::ng-deep .novo-action button,:host.novo-theme-sand ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-silver .header-titles ::ng-deep .novo-icon,:host.novo-accent-silver .header-title ::ng-deep .novo-icon{color:#e2e2e2}:host.novo-accent-silver>section:first-of-type{border-bottom:2px solid #e2e2e2}:host.novo-theme-silver>section:first-of-type{background:#e2e2e2;color:#3d464d;border-bottom:none}:host.novo-theme-silver ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-silver ::ng-deep .novo-action button,:host.novo-theme-silver ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-stone .header-titles ::ng-deep .novo-icon,:host.novo-accent-stone .header-title ::ng-deep .novo-icon{color:#bebebe}:host.novo-accent-stone>section:first-of-type{border-bottom:2px solid #bebebe}:host.novo-theme-stone>section:first-of-type{background:#bebebe;color:#3d464d;border-bottom:none}:host.novo-theme-stone ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-stone ::ng-deep .novo-action button,:host.novo-theme-stone ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-ash .header-titles ::ng-deep .novo-icon,:host.novo-accent-ash .header-title ::ng-deep .novo-icon{color:#a0a0a0}:host.novo-accent-ash>section:first-of-type{border-bottom:2px solid #a0a0a0}:host.novo-theme-ash>section:first-of-type{background:#a0a0a0;color:#3d464d;border-bottom:none}:host.novo-theme-ash ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-ash ::ng-deep .novo-action button,:host.novo-theme-ash ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-slate .header-titles ::ng-deep .novo-icon,:host.novo-accent-slate .header-title ::ng-deep .novo-icon{color:#707070}:host.novo-accent-slate>section:first-of-type{border-bottom:2px solid #707070}:host.novo-theme-slate>section:first-of-type{background:#707070;color:#fff;border-bottom:none}:host.novo-theme-slate ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-slate ::ng-deep .novo-action button,:host.novo-theme-slate ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-onyx .header-titles ::ng-deep .novo-icon,:host.novo-accent-onyx .header-title ::ng-deep .novo-icon{color:#526980}:host.novo-accent-onyx>section:first-of-type{border-bottom:2px solid #526980}:host.novo-theme-onyx>section:first-of-type{background:#526980;color:#fff;border-bottom:none}:host.novo-theme-onyx ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-onyx ::ng-deep .novo-action button,:host.novo-theme-onyx ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-charcoal .header-titles ::ng-deep .novo-icon,:host.novo-accent-charcoal .header-title ::ng-deep .novo-icon{color:#282828}:host.novo-accent-charcoal>section:first-of-type{border-bottom:2px solid #282828}:host.novo-theme-charcoal>section:first-of-type{background:#282828;color:#fff;border-bottom:none}:host.novo-theme-charcoal ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-charcoal ::ng-deep .novo-action button,:host.novo-theme-charcoal ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-moonlight .header-titles ::ng-deep .novo-icon,:host.novo-accent-moonlight .header-title ::ng-deep .novo-icon{color:#1a242f}:host.novo-accent-moonlight>section:first-of-type{border-bottom:2px solid #1a242f}:host.novo-theme-moonlight>section:first-of-type{background:#1a242f;color:#fff;border-bottom:none}:host.novo-theme-moonlight ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-moonlight ::ng-deep .novo-action button,:host.novo-theme-moonlight ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-midnight .header-titles ::ng-deep .novo-icon,:host.novo-accent-midnight .header-title ::ng-deep .novo-icon{color:#202945}:host.novo-accent-midnight>section:first-of-type{border-bottom:2px solid #202945}:host.novo-theme-midnight>section:first-of-type{background:#202945;color:#fff;border-bottom:none}:host.novo-theme-midnight ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-midnight ::ng-deep .novo-action button,:host.novo-theme-midnight ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-darkness .header-titles ::ng-deep .novo-icon,:host.novo-accent-darkness .header-title ::ng-deep .novo-icon{color:#161f27}:host.novo-accent-darkness>section:first-of-type{border-bottom:2px solid #161f27}:host.novo-theme-darkness>section:first-of-type{background:#161f27;color:#fff;border-bottom:none}:host.novo-theme-darkness ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-darkness ::ng-deep .novo-action button,:host.novo-theme-darkness ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-navy .header-titles ::ng-deep .novo-icon,:host.novo-accent-navy .header-title ::ng-deep .novo-icon{color:#0d2d42}:host.novo-accent-navy>section:first-of-type{border-bottom:2px solid #0d2d42}:host.novo-theme-navy>section:first-of-type{background:#0d2d42;color:#fff;border-bottom:none}:host.novo-theme-navy ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-navy ::ng-deep .novo-action button,:host.novo-theme-navy ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-aqua .header-titles ::ng-deep .novo-icon,:host.novo-accent-aqua .header-title ::ng-deep .novo-icon{color:#3bafda}:host.novo-accent-aqua>section:first-of-type{border-bottom:2px solid #3bafda}:host.novo-theme-aqua>section:first-of-type{background:#3bafda;color:#3d464d;border-bottom:none}:host.novo-theme-aqua ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-aqua ::ng-deep .novo-action button,:host.novo-theme-aqua ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-ocean .header-titles ::ng-deep .novo-icon,:host.novo-accent-ocean .header-title ::ng-deep .novo-icon{color:#4a89dc}:host.novo-accent-ocean>section:first-of-type{border-bottom:2px solid #4a89dc}:host.novo-theme-ocean>section:first-of-type{background:#4a89dc;color:#fff;border-bottom:none}:host.novo-theme-ocean ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-ocean ::ng-deep .novo-action button,:host.novo-theme-ocean ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-mint .header-titles ::ng-deep .novo-icon,:host.novo-accent-mint .header-title ::ng-deep .novo-icon{color:#37bc9b}:host.novo-accent-mint>section:first-of-type{border-bottom:2px solid #37bc9b}:host.novo-theme-mint>section:first-of-type{background:#37bc9b;color:#3d464d;border-bottom:none}:host.novo-theme-mint ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-mint ::ng-deep .novo-action button,:host.novo-theme-mint ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-grass .header-titles ::ng-deep .novo-icon,:host.novo-accent-grass .header-title ::ng-deep .novo-icon{color:#8cc152}:host.novo-accent-grass>section:first-of-type{border-bottom:2px solid #8cc152}:host.novo-theme-grass>section:first-of-type{background:#8cc152;color:#fff;border-bottom:none}:host.novo-theme-grass ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-grass ::ng-deep .novo-action button,:host.novo-theme-grass ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-sunflower .header-titles ::ng-deep .novo-icon,:host.novo-accent-sunflower .header-title ::ng-deep .novo-icon{color:#f6b042}:host.novo-accent-sunflower>section:first-of-type{border-bottom:2px solid #f6b042}:host.novo-theme-sunflower>section:first-of-type{background:#f6b042;color:#fff;border-bottom:none}:host.novo-theme-sunflower ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-sunflower ::ng-deep .novo-action button,:host.novo-theme-sunflower ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-bittersweet .header-titles ::ng-deep .novo-icon,:host.novo-accent-bittersweet .header-title ::ng-deep .novo-icon{color:#eb6845}:host.novo-accent-bittersweet>section:first-of-type{border-bottom:2px solid #eb6845}:host.novo-theme-bittersweet>section:first-of-type{background:#eb6845;color:#fff;border-bottom:none}:host.novo-theme-bittersweet ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-bittersweet ::ng-deep .novo-action button,:host.novo-theme-bittersweet ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-grapefruit .header-titles ::ng-deep .novo-icon,:host.novo-accent-grapefruit .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-grapefruit>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-grapefruit>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-grapefruit ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-grapefruit ::ng-deep .novo-action button,:host.novo-theme-grapefruit ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-carnation .header-titles ::ng-deep .novo-icon,:host.novo-accent-carnation .header-title ::ng-deep .novo-icon{color:#d770ad}:host.novo-accent-carnation>section:first-of-type{border-bottom:2px solid #d770ad}:host.novo-theme-carnation>section:first-of-type{background:#d770ad;color:#fff;border-bottom:none}:host.novo-theme-carnation ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-carnation ::ng-deep .novo-action button,:host.novo-theme-carnation ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-lavender .header-titles ::ng-deep .novo-icon,:host.novo-accent-lavender .header-title ::ng-deep .novo-icon{color:#967adc}:host.novo-accent-lavender>section:first-of-type{border-bottom:2px solid #967adc}:host.novo-theme-lavender>section:first-of-type{background:#967adc;color:#fff;border-bottom:none}:host.novo-theme-lavender ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-lavender ::ng-deep .novo-action button,:host.novo-theme-lavender ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-mountain .header-titles ::ng-deep .novo-icon,:host.novo-accent-mountain .header-title ::ng-deep .novo-icon{color:#9678b6}:host.novo-accent-mountain>section:first-of-type{border-bottom:2px solid #9678b6}:host.novo-theme-mountain>section:first-of-type{background:#9678b6;color:#fff;border-bottom:none}:host.novo-theme-mountain ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-mountain ::ng-deep .novo-action button,:host.novo-theme-mountain ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-info .header-titles ::ng-deep .novo-icon,:host.novo-accent-info .header-title ::ng-deep .novo-icon{color:#4a89dc}:host.novo-accent-info>section:first-of-type{border-bottom:2px solid #4a89dc}:host.novo-theme-info>section:first-of-type{background:#4a89dc;color:#fff;border-bottom:none}:host.novo-theme-info ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-info ::ng-deep .novo-action button,:host.novo-theme-info ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-positive .header-titles ::ng-deep .novo-icon,:host.novo-accent-positive .header-title ::ng-deep .novo-icon{color:#4a89dc}:host.novo-accent-positive>section:first-of-type{border-bottom:2px solid #4a89dc}:host.novo-theme-positive>section:first-of-type{background:#4a89dc;color:#fff;border-bottom:none}:host.novo-theme-positive ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-positive ::ng-deep .novo-action button,:host.novo-theme-positive ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-success .header-titles ::ng-deep .novo-icon,:host.novo-accent-success .header-title ::ng-deep .novo-icon{color:#8cc152}:host.novo-accent-success>section:first-of-type{border-bottom:2px solid #8cc152}:host.novo-theme-success>section:first-of-type{background:#8cc152;color:#fff;border-bottom:none}:host.novo-theme-success ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-success ::ng-deep .novo-action button,:host.novo-theme-success ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-negative .header-titles ::ng-deep .novo-icon,:host.novo-accent-negative .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-negative>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-negative>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-negative ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-negative ::ng-deep .novo-action button,:host.novo-theme-negative ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-danger .header-titles ::ng-deep .novo-icon,:host.novo-accent-danger .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-danger>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-danger>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-danger ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-danger ::ng-deep .novo-action button,:host.novo-theme-danger ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-error .header-titles ::ng-deep .novo-icon,:host.novo-accent-error .header-title ::ng-deep .novo-icon{color:#da4453}:host.novo-accent-error>section:first-of-type{border-bottom:2px solid #da4453}:host.novo-theme-error>section:first-of-type{background:#da4453;color:#fff;border-bottom:none}:host.novo-theme-error ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-error ::ng-deep .novo-action button,:host.novo-theme-error ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-warning .header-titles ::ng-deep .novo-icon,:host.novo-accent-warning .header-title ::ng-deep .novo-icon{color:#f6b042}:host.novo-accent-warning>section:first-of-type{border-bottom:2px solid #f6b042}:host.novo-theme-warning>section:first-of-type{background:#f6b042;color:#fff;border-bottom:none}:host.novo-theme-warning ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-warning ::ng-deep .novo-action button,:host.novo-theme-warning ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-empty .header-titles ::ng-deep .novo-icon,:host.novo-accent-empty .header-title ::ng-deep .novo-icon{color:#cccdcc}:host.novo-accent-empty>section:first-of-type{border-bottom:2px solid #cccdcc}:host.novo-theme-empty>section:first-of-type{background:#cccdcc;color:#3d464d;border-bottom:none}:host.novo-theme-empty ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-empty ::ng-deep .novo-action button,:host.novo-theme-empty ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-disabled .header-titles ::ng-deep .novo-icon,:host.novo-accent-disabled .header-title ::ng-deep .novo-icon{color:#bebebe}:host.novo-accent-disabled>section:first-of-type{border-bottom:2px solid #bebebe}:host.novo-theme-disabled>section:first-of-type{background:#bebebe;color:#3d464d;border-bottom:none}:host.novo-theme-disabled ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-disabled ::ng-deep .novo-action button,:host.novo-theme-disabled ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-background .header-titles ::ng-deep .novo-icon,:host.novo-accent-background .header-title ::ng-deep .novo-icon{color:#f7f7f7}:host.novo-accent-background>section:first-of-type{border-bottom:2px solid #f7f7f7}:host.novo-theme-background>section:first-of-type{background:#f7f7f7;color:#3d464d;border-bottom:none}:host.novo-theme-background ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-background ::ng-deep .novo-action button,:host.novo-theme-background ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-backgroundDark .header-titles ::ng-deep .novo-icon,:host.novo-accent-backgroundDark .header-title ::ng-deep .novo-icon{color:#e2e2e2}:host.novo-accent-backgroundDark>section:first-of-type{border-bottom:2px solid #e2e2e2}:host.novo-theme-backgroundDark>section:first-of-type{background:#e2e2e2;color:#3d464d;border-bottom:none}:host.novo-theme-backgroundDark ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-backgroundDark ::ng-deep .novo-action button,:host.novo-theme-backgroundDark ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-presentation .header-titles ::ng-deep .novo-icon,:host.novo-accent-presentation .header-title ::ng-deep .novo-icon{color:#5b6770}:host.novo-accent-presentation>section:first-of-type{border-bottom:2px solid #5b6770}:host.novo-theme-presentation>section:first-of-type{background:#5b6770;color:#fff;border-bottom:none}:host.novo-theme-presentation ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-presentation ::ng-deep .novo-action button,:host.novo-theme-presentation ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-bullhorn .header-titles ::ng-deep .novo-icon,:host.novo-accent-bullhorn .header-title ::ng-deep .novo-icon{color:#ff6900}:host.novo-accent-bullhorn>section:first-of-type{border-bottom:2px solid #ff6900}:host.novo-theme-bullhorn>section:first-of-type{background:#ff6900;color:#3d464d;border-bottom:none}:host.novo-theme-bullhorn ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-bullhorn ::ng-deep .novo-action button,:host.novo-theme-bullhorn ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-pulse .header-titles ::ng-deep .novo-icon,:host.novo-accent-pulse .header-title ::ng-deep .novo-icon{color:#3bafda}:host.novo-accent-pulse>section:first-of-type{border-bottom:2px solid #3bafda}:host.novo-theme-pulse>section:first-of-type{background:#3bafda;color:#3d464d;border-bottom:none}:host.novo-theme-pulse ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-pulse ::ng-deep .novo-action button,:host.novo-theme-pulse ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-company .header-titles ::ng-deep .novo-icon,:host.novo-accent-company .header-title ::ng-deep .novo-icon{color:#39d}:host.novo-accent-company>section:first-of-type{border-bottom:2px solid #3399dd}:host.novo-theme-company>section:first-of-type{background:#39d;color:#fff;border-bottom:none}:host.novo-theme-company ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-company ::ng-deep .novo-action button,:host.novo-theme-company ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-candidate .header-titles ::ng-deep .novo-icon,:host.novo-accent-candidate .header-title ::ng-deep .novo-icon{color:#4b7}:host.novo-accent-candidate>section:first-of-type{border-bottom:2px solid #44bb77}:host.novo-theme-candidate>section:first-of-type{background:#4b7;color:#fff;border-bottom:none}:host.novo-theme-candidate ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-candidate ::ng-deep .novo-action button,:host.novo-theme-candidate ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-lead .header-titles ::ng-deep .novo-icon,:host.novo-accent-lead .header-title ::ng-deep .novo-icon{color:#a69}:host.novo-accent-lead>section:first-of-type{border-bottom:2px solid #aa6699}:host.novo-theme-lead>section:first-of-type{background:#a69;color:#fff;border-bottom:none}:host.novo-theme-lead ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-lead ::ng-deep .novo-action button,:host.novo-theme-lead ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-contact .header-titles ::ng-deep .novo-icon,:host.novo-accent-contact .header-title ::ng-deep .novo-icon{color:#fa4}:host.novo-accent-contact>section:first-of-type{border-bottom:2px solid #ffaa44}:host.novo-theme-contact>section:first-of-type{background:#fa4;color:#fff;border-bottom:none}:host.novo-theme-contact ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-contact ::ng-deep .novo-action button,:host.novo-theme-contact ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-clientcontact .header-titles ::ng-deep .novo-icon,:host.novo-accent-clientcontact .header-title ::ng-deep .novo-icon{color:#fa4}:host.novo-accent-clientcontact>section:first-of-type{border-bottom:2px solid #ffaa44}:host.novo-theme-clientcontact>section:first-of-type{background:#fa4;color:#fff;border-bottom:none}:host.novo-theme-clientcontact ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-clientcontact ::ng-deep .novo-action button,:host.novo-theme-clientcontact ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-opportunity .header-titles ::ng-deep .novo-icon,:host.novo-accent-opportunity .header-title ::ng-deep .novo-icon{color:#625}:host.novo-accent-opportunity>section:first-of-type{border-bottom:2px solid #662255}:host.novo-theme-opportunity>section:first-of-type{background:#625;color:#fff;border-bottom:none}:host.novo-theme-opportunity ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-opportunity ::ng-deep .novo-action button,:host.novo-theme-opportunity ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-job .header-titles ::ng-deep .novo-icon,:host.novo-accent-job .header-title ::ng-deep .novo-icon{color:#b56}:host.novo-accent-job>section:first-of-type{border-bottom:2px solid #bb5566}:host.novo-theme-job>section:first-of-type{background:#b56;color:#fff;border-bottom:none}:host.novo-theme-job ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-job ::ng-deep .novo-action button,:host.novo-theme-job ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-joborder .header-titles ::ng-deep .novo-icon,:host.novo-accent-joborder .header-title ::ng-deep .novo-icon{color:#b56}:host.novo-accent-joborder>section:first-of-type{border-bottom:2px solid #bb5566}:host.novo-theme-joborder>section:first-of-type{background:#b56;color:#fff;border-bottom:none}:host.novo-theme-joborder ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-joborder ::ng-deep .novo-action button,:host.novo-theme-joborder ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-submission .header-titles ::ng-deep .novo-icon,:host.novo-accent-submission .header-title ::ng-deep .novo-icon{color:#a9adbb}:host.novo-accent-submission>section:first-of-type{border-bottom:2px solid #a9adbb}:host.novo-theme-submission>section:first-of-type{background:#a9adbb;color:#3d464d;border-bottom:none}:host.novo-theme-submission ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-submission ::ng-deep .novo-action button,:host.novo-theme-submission ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-sendout .header-titles ::ng-deep .novo-icon,:host.novo-accent-sendout .header-title ::ng-deep .novo-icon{color:#747884}:host.novo-accent-sendout>section:first-of-type{border-bottom:2px solid #747884}:host.novo-theme-sendout>section:first-of-type{background:#747884;color:#fff;border-bottom:none}:host.novo-theme-sendout ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-sendout ::ng-deep .novo-action button,:host.novo-theme-sendout ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-placement .header-titles ::ng-deep .novo-icon,:host.novo-accent-placement .header-title ::ng-deep .novo-icon{color:#0b344f}:host.novo-accent-placement>section:first-of-type{border-bottom:2px solid #0b344f}:host.novo-theme-placement>section:first-of-type{background:#0b344f;color:#fff;border-bottom:none}:host.novo-theme-placement ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-placement ::ng-deep .novo-action button,:host.novo-theme-placement ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-note .header-titles ::ng-deep .novo-icon,:host.novo-accent-note .header-title ::ng-deep .novo-icon{color:#747884}:host.novo-accent-note>section:first-of-type{border-bottom:2px solid #747884}:host.novo-theme-note>section:first-of-type{background:#747884;color:#fff;border-bottom:none}:host.novo-theme-note ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-note ::ng-deep .novo-action button,:host.novo-theme-note ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-contract .header-titles ::ng-deep .novo-icon,:host.novo-accent-contract .header-title ::ng-deep .novo-icon{color:#454ea0}:host.novo-accent-contract>section:first-of-type{border-bottom:2px solid #454ea0}:host.novo-theme-contract>section:first-of-type{background:#454ea0;color:#fff;border-bottom:none}:host.novo-theme-contract ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-contract ::ng-deep .novo-action button,:host.novo-theme-contract ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-jobCode .header-titles ::ng-deep .novo-icon,:host.novo-accent-jobCode .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-jobCode>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-jobCode>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-jobCode ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-jobCode ::ng-deep .novo-action button,:host.novo-theme-jobCode ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-earnCode .header-titles ::ng-deep .novo-icon,:host.novo-accent-earnCode .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-earnCode>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-earnCode>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-earnCode ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-earnCode ::ng-deep .novo-action button,:host.novo-theme-earnCode ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-invoiceStatement .header-titles ::ng-deep .novo-icon,:host.novo-accent-invoiceStatement .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-invoiceStatement>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-invoiceStatement>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-invoiceStatement ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-invoiceStatement ::ng-deep .novo-action button,:host.novo-theme-invoiceStatement ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-billableCharge .header-titles ::ng-deep .novo-icon,:host.novo-accent-billableCharge .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-billableCharge>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-billableCharge>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-billableCharge ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-billableCharge ::ng-deep .novo-action button,:host.novo-theme-billableCharge ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-payableCharge .header-titles ::ng-deep .novo-icon,:host.novo-accent-payableCharge .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-payableCharge>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-payableCharge>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-payableCharge ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-payableCharge ::ng-deep .novo-action button,:host.novo-theme-payableCharge ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-user .header-titles ::ng-deep .novo-icon,:host.novo-accent-user .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-user>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-user>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-user ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-user ::ng-deep .novo-action button,:host.novo-theme-user ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-corporateUser .header-titles ::ng-deep .novo-icon,:host.novo-accent-corporateUser .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-corporateUser>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-corporateUser>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-corporateUser ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-corporateUser ::ng-deep .novo-action button,:host.novo-theme-corporateUser ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-distributionList .header-titles ::ng-deep .novo-icon,:host.novo-accent-distributionList .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-distributionList>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-distributionList>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-distributionList ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-distributionList ::ng-deep .novo-action button,:host.novo-theme-distributionList ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-credential .header-titles ::ng-deep .novo-icon,:host.novo-accent-credential .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-credential>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-credential>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-credential ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-credential ::ng-deep .novo-action button,:host.novo-theme-credential ::ng-deep .novo-action .novo-button{color:inherit}:host.novo-accent-person .header-titles ::ng-deep .novo-icon,:host.novo-accent-person .header-title ::ng-deep .novo-icon{color:#696d79}:host.novo-accent-person>section:first-of-type{border-bottom:2px solid #696d79}:host.novo-theme-person>section:first-of-type{background:#696d79;color:#fff;border-bottom:none}:host.novo-theme-person ::ng-deep .novo-title{color:inherit;overflow:hidden;padding-right:.5rem}:host.novo-theme-person ::ng-deep .novo-action button,:host.novo-theme-person ::ng-deep .novo-action .novo-button{color:inherit}:host>main{padding:4px 16px 4px 32px}:host>::ng-deep novo-nav{padding-left:16px}:host>::ng-deep novo-nav.block{padding-left:0}:host.condensed .header-title,:host.condensed .header-titles{line-height:1.375}:host.condensed>section{height:3.6rem}:host.condensed ::ng-deep .novo-icon{margin-right:.5rem!important;font-size:1.8rem}:host .header-actions{display:flex;flex-flow:row nowrap}\n"] }]
        }], ctorParameters: () => [{ type: i0.ElementRef }], propDecorators: { role: [{
                type: HostBinding,
                args: ['attr.role']
            }], headerClass: [{
                type: HostBinding,
                args: ['class']
            }], condensed: [{
                type: HostBinding,
                args: ['class.condensed']
            }, {
                type: Input
            }], title: [{
                type: Input
            }], subTitle: [{
                type: Input
            }], icon: [{
                type: Input
            }], size: [{
                type: Input
            }], hb_isSizeSmall: [{
                type: HostBinding,
                args: ['class.header-size-small']
            }], hb_isSizeLarge: [{
                type: HostBinding,
                args: ['class.header-size-large']
            }], hb_isSizeDefault: [{
                type: HostBinding,
                args: ['class.header-size-default']
            }], theme: [{
                type: HostBinding,
                args: ['attr.theme']
            }, {
                type: Input
            }] } });

class NovoHeaderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderModule, declarations: [NovoHeaderComponent, NovoUtilActionComponent, NovoUtilsComponent, NovoHeaderSpacer], imports: [CommonModule, NovoCommonModule, NovoIconModule, NovoButtonModule], exports: [NovoHeaderComponent, NovoUtilActionComponent, NovoUtilsComponent, NovoHeaderSpacer] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderModule, imports: [CommonModule, NovoCommonModule, NovoIconModule, NovoButtonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NovoHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, NovoCommonModule, NovoIconModule, NovoButtonModule],
                    declarations: [NovoHeaderComponent, NovoUtilActionComponent, NovoUtilsComponent, NovoHeaderSpacer],
                    exports: [NovoHeaderComponent, NovoUtilActionComponent, NovoUtilsComponent, NovoHeaderSpacer],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NovoHeaderComponent, NovoHeaderModule, NovoHeaderSpacer, NovoUtilActionComponent, NovoUtilsComponent };
//# sourceMappingURL=novo-elements-elements-header.mjs.map
